#include <QApplication>
#include "CalibrationForm.h"
#include <QPushButton>
#include <QProgressBar>
#include <QSlider>
#include <QtWidgets/QApplication>
#include <QPushButton>
#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <QInputDialog>
#include <QDir>
#include <QFormLayout>
#include  <QLayout>
#include  <QGroupBox>
#include <QMainWindow>
#include <QTextEdit>
#include <QDialogButtonBox>
#include <QtWidgets/QLabel>
#include <QMenuBar>
#include <QSpinBox>
#include<QComboBox>
#include <QScrollArea>
#include <QCheckBox>

#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <QFileDialog>
#include <QMessageBox>

#include <iomanip>
#include <unistd.h>
#include <arpa/inet.h>
#include <fstream>
#include "opencv2/opencv.hpp"
#include <chrono>
#include <atomic>

using namespace std;




extern void Calibrate(int Num_CalibPoints,vector <cv::Point3f> RealWorldCoordinates, vector<string> IPstrings,vector<string> JetsonsInfo,vector<int> ports,string SavingDir);
extern int IterNum;
extern int globaltrack;
extern int WorldCoordinateNumber;
extern atomic <bool> CalibDone;

int w=800;
int VLast_Points=5;
int Vlast_CamNum=4;

string currentDateTime() {
    time_t     now = time(0);
    struct tm  tstruct;
    char       buf[80];
    tstruct = *localtime(&now);
    strftime(buf, sizeof(buf), "%Y.%m.%d_%R", &tstruct);
    return buf;
}

CalibrationForm::CalibrationForm()
{


	//for the main 1 form
	JetsonsRunning=0;

	RealCoordinates[0]=tr("0 0 0");
	RealCoordinates[1]=tr("50 0 0");
	RealCoordinates[2]=tr("0 50 0");
	RealCoordinates[3]=tr("0 0 50");
	RealCoordinates[4]=tr("50 50 50");
	for(int i=0;i<40;i++)
	{
		if(i>4)
		{
			RealCoordinates[i]=tr("");
		}
		if(i<10){
			int PORTVAL=1111*(i+1);
			QString qstr = QString::fromStdString(to_string(PORTVAL));
			Ports[i]=qstr;
	   		IPs[i]=tr("10.0.0.10%1").arg(i + 1);
	   	}
	}
	//setMinimumWidth(w);
	setWindowTitle(tr("Calibration Configuration"));
 	QS1=new QSpinBox;
 	QS2=new QSpinBox;
 	QS3=new QSpinBox;
 	buttonBox = new QDialogButtonBox(QDialogButtonBox::Ok | QDialogButtonBox::Cancel);
 	buttonBox2 = new QDialogButtonBox(QDialogButtonBox::Cancel);
 	NetworkConnection = new QPushButton(tr("Connect to All Jetsons"));
    AskCalibPointNum();
    AskRealPointNum();
    AskCameraNumber();
    AssignIP_PORT(4);
    SaveMatrix();
    JetsonNames();
    
	AskRealPointNum();
	
	int V = QS2->value();
	RealPointForm(V);
	
    mainLayout = new QGridLayout();
    mainLayout->addWidget(QuestionPoints1,0,0,2,1); //initial form
    mainLayout->addWidget(QuestionPoints2,3,0,1,1);
   
    mainLayout->addWidget(RealPoints,4,0,1,1);
	mainLayout->addWidget(CameraNum,0,1,1,1);
	mainLayout->addWidget(JetsonNameDialog,3,1,1,1);
	mainLayout->addWidget(NetworkInfo,4,1,2,1);
	mainLayout->addWidget(SavingDialog,6,0,1,2); //Browse
	mainLayout->addWidget(buttonBox,8,1,2,1); //OK and Cancel
	
	setLayout(mainLayout);
	
	
	//for the second main form
	mainLayout2 = new QGridLayout();
	CalibrationButton = new QPushButton(tr("Start"));
 	Start3DCamTracking = new QPushButton(tr("Start Tracking"));
 	Start3DRealTracking = new QPushButton(tr("Start Tracking"));
	
	connect(QS2, static_cast<void (QSpinBox::*)(int)>(&QSpinBox::valueChanged),this, &CalibrationForm::AddRemoveCoordinates);
	connect(QS3, static_cast<void (QSpinBox::*)(int)>(&QSpinBox::valueChanged),this, &CalibrationForm::AddRemoveJetson);
	connect(BrowseButton, SIGNAL (clicked()), this, SLOT (ChooseDir()));
	connect(NetworkConnection, SIGNAL (clicked()), this, SLOT (RunJetsons()));
	connect(buttonBox, &QDialogButtonBox::accepted, this, &CalibrationForm::MoveToNextWindow);
	connect(buttonBox, &QDialogButtonBox::rejected, this, &CalibrationForm::reject);
	
	//for next window second main
	connect(buttonBox2, static_cast<void (QDialogButtonBox::*)()>(&QDialogButtonBox::rejected), this, &CalibrationForm::EndCalib);
	connect(CalibrationButton, SIGNAL (clicked()), this, SLOT (StartCalibration()));
	connect(Start3DCamTracking, SIGNAL (clicked()), this, SLOT (GNUplotTracking()));
	connect(Start3DRealTracking, SIGNAL (clicked()), this, SLOT (GNUplotTrackingRealWorld()));

	setMinimumWidth(w);
	
}


void CalibrationForm::AskCalibPointNum()
{
    QuestionPoints1 = new QGroupBox(tr("3D Calibration"));
    QFormLayout *layout = new QFormLayout;
    QS1->setMaximum(10000);
    QS1->setValue(500);
    layout->addRow(new QLabel(tr("Number of points:")), QS1 );
    QuestionPoints1->setLayout(layout);
}

void CalibrationForm::AskRealPointNum()
{
    QuestionPoints2 = new QGroupBox("Real-World Calibration");
    QFormLayout *layout = new QFormLayout;
    QS2->setMaximum(100);
    QS2->setMinimum(5);
    layout->addRow(new QLabel(tr("Number of points: ")), QS2 );
    QuestionPoints2->setLayout(layout);
}

void CalibrationForm::RealPointForm(int a)
{
    RealPoints = new QGroupBox(tr("Coordinates (X Y Z)"));
	QGridLayout *layout= new QGridLayout;
	
    for (int i = 0; i < a; ++i) {
        labels[i] = new QLabel(tr("Point # %1:").arg(i + 1));
        lineEdits[i] = new QLineEdit;
        lineEdits[i]->setText(RealCoordinates[i]);
        layout->addWidget(labels[i], i , 0);
        layout->addWidget(lineEdits[i], i , 1);

    }

    RealPoints->setLayout(layout);
}

void CalibrationForm::AssignIP_PORT(int a)
{
    NetworkInfo = new QGroupBox(tr("Network Information"));
	QGridLayout *layout= new QGridLayout;
	QLabel *HostLabel = new QLabel(tr("Host Machin IP:"));
	lineEditsHostIP = new QLineEdit(HostIP);
	lineEditsHostIP->setInputMask("000.000.000.000");
	layout->addWidget(HostLabel, 0, 0);
	layout->addWidget(lineEditsHostIP, 0, 1);
    for (int i = 0; i < a; ++i) {
        labels2[i] = new QLabel(tr("Jetson %1 IP adr:").arg(i + 1));
        lineEdits2[i] = new QLineEdit;
        lineEdits2[i]->setInputMask("000.000.000.000");
        lineEdits2[i]->setText(IPs[i]);
        layout->addWidget(labels2[i], i + 1, 0);
        layout->addWidget(lineEdits2[i], i + 1, 1);
    }
    for (int i = 0; i < a; ++i) {
        labels3[i] = new QLabel(tr(" Port:"));
        lineEdits3[i] = new QLineEdit;
        lineEdits3[i]->setInputMask("0000");
        lineEdits3[i]->setText(Ports[i]);
        layout->addWidget(labels3[i], i + 1, 2);
        layout->addWidget(lineEdits3[i], i + 1, 3);
    }
    
    layout->addWidget(NetworkConnection, a+2, 3);
    layout->setColumnStretch(0, 5);
    layout->setColumnStretch(1, 5);
    layout->setColumnStretch(2, 2);
    layout->setColumnStretch(3, 5);
    
    NetworkInfo->setLayout(layout);
}


void CalibrationForm::AskCameraNumber()
{
    CameraNum = new QGroupBox(tr("Cameras"));
    QFormLayout *layout = new QFormLayout;
    QS3->setMaximum(10);
    QS3->setMinimum(2);
    QS3->setValue(4);
    layout->addRow(new QLabel(tr("Number of cameras: ")), QS3 );
    CameraNum->setLayout(layout);
}


void CalibrationForm::SaveMatrix()
{

	string defaultFilename="Calibration-"+currentDateTime();
    QString qstr = QString::fromStdString(defaultFilename);
    string path(getenv("HOME"));
    path=path+"/Desktop";
	QString defualtpath = QString::fromStdString(path);
	
	SavingDialog = new QGroupBox(tr("Save Output Files"));
	QGridLayout *layout = new QGridLayout;
    BrowseButton = new QPushButton(tr("Browse"));
    QLabel *DirName = new QLabel(tr("Calibration Name"));
    QLabel *LabelOutputFolder = new QLabel(tr("Output Folder"));
    lineEditSaving = new QLineEdit(defualtpath);
    lineEditCalibrationName=new QLineEdit(qstr);
    
    layout->addWidget(DirName,0,0,1,1);
    layout->addWidget(lineEditCalibrationName,0,1,1,1);
    layout->addWidget(LabelOutputFolder,1,0,1,1);
    layout->addWidget(lineEditSaving,1,1,1,1);
    layout->addWidget(BrowseButton,1,2,1,1);
    
    SavingDialog->setLayout(layout);
}


void CalibrationForm::JetsonNames()
{
	
	JetsonNameDialog = new QGroupBox(tr("Jetsons"));
   	QGridLayout *layout= new QGridLayout;
    lineEditJetsonNames = new QLineEdit(Jusernames);
    lineEditJetsonPass = new QLineEdit(password);
    
    layout->addWidget(new QLabel(tr("Jetson Username: ")),0,0);
   	layout->addWidget(lineEditJetsonNames,0,1);
   	
   	layout->addWidget(new QLabel(tr("Password: ")),0,2);
   	layout->addWidget(lineEditJetsonPass,0,3);

    JetsonNameDialog->setLayout(layout);
}


void CalibrationForm::CalibrationMenu3D()
{
	QuestionPoints3 = new QGroupBox("3D Calibration");
	QGridLayout *layout= new QGridLayout;
	Calib3DTextInfo = new QLabel(tr("Grab an LED and try to cover tracking space for 3D calibration.\n\nStart the process by clicking the Start button below.\n\n"));
	CollectedPoints = new QLabel(tr("0/ %1 Points Collected").arg(NumCalibrationPoints));
	CalibrationProgress = new QProgressBar;
	CalibrationProgress->setOrientation(Qt::Horizontal);
	CalibrationProgress->setRange(0,100);
	CalibrationProgress->setValue(0);
	layout->addWidget(Calib3DTextInfo,0,0,1,3);
	layout->addWidget(CalibrationButton,3,0,1,1);
	layout->addWidget(CalibrationProgress,3,1,1,1);
	
	layout->addWidget(CollectedPoints,5,1,1,1);
	
	layout->setColumnStretch(0, 5);
    layout->setColumnStretch(1, 25);
   
	QuestionPoints3->setLayout(layout);
	
}

void CalibrationForm::TrackingInCameraCoordinate()
{
	QuestionPoints4 = new QGroupBox("Initial 3D Tracking");
	QGridLayout *layout= new QGridLayout;
	QLabel *TrackText = new QLabel(tr("Try to move your target in all 3 axes to create a 3D star.\n\nStart tracking in reference camera coordinate by clicking the Start button below. \n\n"));
	layout->addWidget(TrackText,0,0,2,4);
	layout->addWidget(Start3DCamTracking,2,0,1,1);
	QuestionPoints4->setLayout(layout);
}

void CalibrationForm::TrackingInRealWorldCoordinate()
{
	QuestionPoints6 = new QGroupBox("Real-World Tracking");
	QGridLayout *layout= new QGridLayout;
	QLabel *TrackText = new QLabel(tr("\nStart tracking in Real-World coordinates using the latest calculated matrix\n"));
	layout->addWidget(TrackText,0,0,2,4);
	layout->addWidget(Start3DRealTracking,2,0,1,1);
	QuestionPoints6->setLayout(layout);
}

void CalibrationForm::RealWorldCalibrationProcess(int a)
{
	QuestionPoints5 = new QGroupBox("Real World Calibration");
	QGridLayout *layout = new QGridLayout;
	
	for(int i=0;i<a;i++){
		QString LabelString=tr("Please put your target at (")+RealCoordinates[i]+tr(") and press OK."); 
		RealWorldCoordinateLabels[i]=new QLabel(LabelString);
		RealWorldOKButton[i]=new QPushButton(tr("OK"));
		connect(RealWorldOKButton[i], SIGNAL (clicked()), this, SLOT (MoveToNextRealCoordinates()));
		if(i>0){
			RealWorldOKButton[i]->setEnabled(false);
			RealWorldCoordinateLabels[i]->setEnabled(false);
		}
		layout->addWidget(RealWorldCoordinateLabels[i],i,0);
		layout->addWidget(RealWorldOKButton[i],i,1);
	}
	
	layout->setColumnStretch(0, 20);
    layout->setColumnStretch(1, 5);
   

	QuestionPoints5->setLayout(layout);

}

//SLOTS//////////////////////////////

void CalibrationForm::AddRemoveCoordinates()
{  
	for(int i=0;i<VLast_Points;i++)
	{
		RealCoordinates[i]=lineEdits[i]->text();
	}
	int V2 = QS2->value();
	mainLayout->removeWidget(RealPoints);	
	RealPoints->setParent(NULL);
	RealPointForm(V2);
	mainLayout->addWidget(RealPoints,4,0,1,1);
	setMinimumWidth(w);
	adjustSize();
	setMinimumWidth(w);
	VLast_Points=V2;
	
}


void CalibrationForm::AddRemoveJetson()
{  
	for(int i=0;i<Vlast_CamNum;i++)
	{
		IPs[i]=lineEdits2[i]->text();
		Ports[i]=lineEdits3[i]->text();
		HostIP=lineEditsHostIP->text();
	}
	int V = QS3->value();
	mainLayout->removeWidget(NetworkInfo);	
	NetworkInfo->setParent(NULL);
	AssignIP_PORT(V);
	mainLayout->addWidget(NetworkInfo,4,1,2,1);
	adjustSize();	
	Vlast_CamNum=V;
}

void CalibrationForm::ChooseDir()
{
	string path(getenv("HOME"));
    path=path+"/Desktop";
	QString qstr = QString::fromStdString(path);
 	QString QfileName = QFileDialog::getExistingDirectory(this, tr("Open Directory"),qstr,QFileDialog::ShowDirsOnly| QFileDialog::DontResolveSymlinks);
	lineEditSaving->setText(QfileName);
}


void CalibrationForm::AssigneInputs()
{
	SavingDir="";
	cout<<SavingDir.size()<<endl;
	CameraNumbers = QS3->value();
	CalibRealPointNum=QS2->value();
	NumCalibrationPoints=QS1->value();
	if(lineEditSaving->text().toStdString().size()>0)
		SavingDir=lineEditSaving->text().toStdString() + "/"+lineEditCalibrationName->text().toStdString();
	ports.clear();
	RealWorldCoordinates.clear();
	//save IP and Port Info
	HostIP=lineEditsHostIP->text();
	cout<<"done"<<endl;
	for(int i=0;i<CameraNumbers;i++)
	{
		IPs[i]=lineEdits2[i]->text();
		Ports[i]=lineEdits3[i]->text();
		stringstream ss(Ports[i].toStdString());
		int PN;
		ss>>PN;
		ports.push_back(PN);
	}
	password=lineEditJetsonPass->text();
	Jusernames=lineEditJetsonNames->text();
	//save RealPoints for calibration
	
	for(int i=0;i<CalibRealPointNum;i++)
	{
		RealCoordinates[i]=lineEdits[i]->text();
		stringstream ss(RealCoordinates[i].toStdString());
		float x,y,z;
		if(RealCoordinates[i].toStdString().size()>1){
			ss>>x>>y>>z;
			RealWorldCoordinates.push_back(cv::Point3f(x,y,z));
		}
	}	
}


void CalibrationForm::RunJetsons()
{
	
	if(JetsonsRunning==0){
		
		NetworkConnection->setEnabled(false);
		AssigneInputs();
		QMessageBox::StandardButton reply;
	  	reply = QMessageBox::question(this, "Confirm", "Connect to Jetsons?", QMessageBox::Yes|QMessageBox::No);
	  	if(reply== QMessageBox::Yes)
	  	{
	  		NetworkConnection->setText("Connecting ....");
			QApplication::processEvents();
			//Run all the jetsons
			for(int i =0;i<CameraNumbers;i++)
			{
				string ip=IPs[i].toStdString();
				string recport=Ports[i].toStdString();
				string hostip=HostIP.toStdString();
				string loginCmd="konsole -e sshpass -p "+password.toStdString()+" ssh -o StrictHostKeyChecking=no -t "+Jusernames.toStdString() +"@"+ip;
				string ProcCmd=" \"echo "+password.toStdString()+" | sudo -S ./Desktop/cpu_gpu.sh ;  sudo   ./Desktop/SingleLEDTrack/M "+hostip+" "+ recport +"  900000 \"";
				string FinalCmd=loginCmd+ProcCmd;
				system(FinalCmd.c_str());
			}
			JetsonsRunning=1;
			NetworkConnection->setText("Close All Connections");
		}
		
	}
	
	else
	{	
		system("pkill konsole");
		NetworkConnection->setText("Connect to All Jetsons");
		JetsonsRunning=0;
	}
	
	NetworkConnection->setEnabled(true);
}


void CalibrationForm::MoveToNextWindow()
{
	AssigneInputs();
	
	if(JetsonsRunning==0)
	{
		QMessageBox msgBox;
		msgBox.setText("Please press \"Connect to All Jetsons\" to establish all connections before calibration process.");
		msgBox.exec();
	}
	if(SavingDir.size()==0)
	{
		QMessageBox msgBox;
		msgBox.setText("Please select the directory and filename for saving the output");
		msgBox.exec();
	}
	
	if(JetsonsRunning==1 & SavingDir.size()>0){
		cout<<SavingDir<<endl;
		string CreatOutputDirectory="mkdir "+SavingDir;
		system(CreatOutputDirectory.c_str());
		QMessageBox::StandardButton reply;
		reply = QMessageBox::question(this, "Confirm", "Make sure all jetsons are connected. \nYou wont be able to change parameters during calibration process.\nContinue with this configuration? ", QMessageBox::Yes|QMessageBox::No);
	  	if(reply== QMessageBox::Yes)
	  	{
	  		delete mainLayout;
			qDeleteAll(this->children());
	  		CalibrationMenu3D();
	  		mainLayout2->addWidget(QuestionPoints3,0,0,1,3); 
	  		mainLayout2->addWidget(buttonBox2,5,0,1,3);

			setLayout(mainLayout2);
			adjustSize();

		}
	}	
}

void CalibrationForm::StartCalibration()
{
	CalibrationButton->setEnabled(false);
	vector <string> IPstrings;
	string hostip=HostIP.toStdString();
	hostip.erase(remove(hostip.begin(),hostip.end(),' '),hostip.end());
	IPstrings.push_back(hostip);
	for(int i=0;i<ports.size();i++)
	{
		string Jip=IPs[i].toStdString();
		cout<<Jip<<endl;
		Jip.erase(remove(Jip.begin(),Jip.end(),' '),Jip.end());
		cout<<Jip<<endl;
		IPstrings.push_back(Jip);
	}
	vector <string> JetsonsInfo;
	JetsonsInfo.push_back(Jusernames.toStdString());
	JetsonsInfo.push_back(password.toStdString());
	CalibDone=false;
	Calibrate(NumCalibrationPoints,RealWorldCoordinates,IPstrings,JetsonsInfo,ports,SavingDir);	
	while(1)
	{
		float percent=float((100*IterNum)/NumCalibrationPoints);
		CalibrationProgress->setValue(int(percent));
		string FractionPointsCollected=to_string(IterNum)+"/"+to_string(NumCalibrationPoints)+" Points Collected \n";
		QString qstr = QString::fromStdString(FractionPointsCollected);
		CollectedPoints->setText(qstr);
		QApplication::processEvents();
		if(percent==100)
			break;
	}
	TrackingInCameraCoordinate();
	mainLayout2->addWidget(QuestionPoints4,1,0);		
}

void CalibrationForm::GNUplotTracking()
{
	if(globaltrack==0){
		globaltrack=1;
		Start3DCamTracking->setText("Stop Tracking");	
	}
	else
	{
		globaltrack=0;
		system("pkill gnuplot");
		Start3DCamTracking->setEnabled(false);
		RealWorldCalibrationProcess(CalibRealPointNum);
	  	mainLayout2->addWidget(QuestionPoints5,3,0,1,2);
	}	
}

void CalibrationForm::GNUplotTrackingRealWorld()
{
	if(globaltrack==0){
		globaltrack=1;
		Start3DRealTracking->setText("Stop Tracking");
	}
	else
	{
		globaltrack=0;
		system("pkill gnuplot");
		system("pkill konsole");
		Start3DRealTracking->setEnabled(false);
		QMessageBox msgBox;
		msgBox.setText("Calibration is done!");
		msgBox.exec();
		close();
		
		
	}
		
}

void CalibrationForm::MoveToNextRealCoordinates()
{
	
	WorldCoordinateNumber=WorldCoordinateNumber+1;
	RealWorldOKButton[WorldCoordinateNumber-1]->setEnabled(false);
	RealWorldOKButton[WorldCoordinateNumber-1]->setText("Done!");
	RealWorldCoordinateLabels[WorldCoordinateNumber-1]->setEnabled(false);
	if(WorldCoordinateNumber<CalibRealPointNum){
		RealWorldOKButton[WorldCoordinateNumber]->setEnabled(true);
		RealWorldCoordinateLabels[WorldCoordinateNumber]->setEnabled(true);
	}
	if(WorldCoordinateNumber==CalibRealPointNum)
	{
		system("pkill gnuplot");
		cout<<"hi"<<endl;
		TrackingInRealWorldCoordinate();
		mainLayout2->addWidget(QuestionPoints6,4,0,1,3);
	}
	
}

void CalibrationForm::EndCalib()
{
	CalibDone=true;
	close();
}

