#ifndef CALIBRATIONFORM_H
#define CALIBRATIONFORM_H

#include <QApplication>
#include <QPushButton>
#include <QProgressBar>

#include <QSlider>
#include <QtWidgets/QApplication>
#include <QPushButton>

#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <QInputDialog>
#include <QDir>
#include <QFormLayout>
#include  <QLayout>

#include  <QGroupBox>
#include <QMainWindow>


#include <QTextEdit>
#include <QDialogButtonBox>
#include <QtWidgets/QLabel>
#include <QMenuBar>
#include <QSpinBox>
#include <QComboBox>
#include <QCheckBox>
#include <QSlider>


#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "opencv2/opencv.hpp"

using namespace std;
extern int IterNum;
class CalibrationForm : public QDialog
{
    
Q_OBJECT

public:
    CalibrationForm();
   	QString Ports[40];
   	QString IPs[40];
   	QString HostIP=tr("10.0.0.100");
   	QString RealCoordinates[40];
   	vector <int> ports;
	vector <cv::Point3f> RealWorldCoordinates;
	int CameraNumbers;
	int CalibRealPointNum;
	int NumCalibrationPoints;
	int JetsonsRunning;
	string SavingDir;
	QString password="1234asdfdsa";
	QString Jusernames="nvidia";


private:

    void RealPointForm(int a);
    void AskCalibPointNum();
    void AskRealPointNum();
   	void AssignIP_PORT(int a);
   	void AskCameraNumber();
   	void SaveMatrix();
   	void JetsonNames();
   	void AssigneInputs();
   	void CalibrationMenu3D();
   	void TrackingInCameraCoordinate();
   	void TrackingInRealWorldCoordinate();
   	void RealWorldCalibrationProcess(int a);
   	
   	
	QSpinBox *QS1;
	QSpinBox *QS2;
	QSpinBox *QS3;
    QGroupBox *horizontalGroupBox;
    QGroupBox *RealPoints;
    QGroupBox *CameraNum;
    QGroupBox *QuestionPoints1;
    QGroupBox *QuestionPoints2;
    QGroupBox *QuestionPoints3;
    QGroupBox *QuestionPoints4;
    QGroupBox *QuestionPoints5;
   	QGroupBox *QuestionPoints6;
    QGroupBox *NetworkInfo;
    QGroupBox *SavingDialog;
    QGroupBox *JetsonNameDialog;
    QLabel *labels[40];
    QLineEdit *lineEdits[40];
    QLabel *Calib3DTextInfo;
    QLabel *CollectedPoints;
    QLabel *labels2[40];
    QLabel *labels3[40];
    QLabel *RealWorldCoordinateLabels[40];
    QLineEdit *lineEdits2[40];
    QLineEdit *lineEdits3[40];
    QLineEdit *lineEditSaving;
    QLineEdit *lineEditCalibrationName;
    QLineEdit *lineEditJetsonNames;
    QLineEdit *lineEditJetsonPass;
    QLineEdit * lineEditsHostIP;
    QDialogButtonBox *buttonBox;
    QDialogButtonBox *buttonBox2;
    QPushButton *CalibrationButton;
 	QGridLayout *mainLayout;
 	QGridLayout *mainLayout2;
 	QPushButton *BrowseButton;
 	QPushButton *Start3DCamTracking;
 	QPushButton *Start3DRealTracking;
 	QPushButton *NetworkConnection;
 	QPushButton *RealWorldOKButton[40];
 	QProgressBar *CalibrationProgress;
 	
 	

    int logIterValue;
    public slots:
    	void AddRemoveCoordinates();
    	void ChooseDir();
    	void AddRemoveJetson();
    	void RunJetsons();
    	void MoveToNextWindow();
    	void StartCalibration();
    	void GNUplotTracking();
    	void MoveToNextRealCoordinates();
    	void GNUplotTrackingRealWorld();
    	void EndCalib();

};

#endif // WINDOW_H
