#include <QApplication>
#include "LoadConfiguration.h"
#include <QPushButton>
#include <QProgressBar>
#include <QSlider>
#include <QtWidgets/QApplication>
#include <QPushButton>
#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <QInputDialog>
#include <QDir>
#include <QFormLayout>
#include  <QLayout>
#include  <QGroupBox>
#include <QMainWindow>
#include <QTextEdit>
#include <QDialogButtonBox>
#include <QtWidgets/QLabel>
#include <QMenuBar>
#include <QSpinBox>
#include<QComboBox>
#include <QScrollArea>
#include <QCheckBox>

#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <QFileDialog>
#include <QMessageBox>

#include <iomanip>
#include <unistd.h>
#include <arpa/inet.h>
#include <fstream>
#include "opencv2/opencv.hpp"
#include <chrono>
#include "../src/ParserINI/INIReader.h"
#include <atomic>

using namespace std;
using namespace cv;

extern atomic <bool> TrackDone;
extern int w;

extern string currentDateTime();


extern void RunEthoLoop( int CAM_NUM, vector<Mat> PM, Mat TransformMatrix, vector<int> AllPorts, int HasLiveCamera, LiveCamera LC,int HasCloseUp, CloseUpSystem CLUP, int HasRecoBox, int WhichRecoBoxMode,ConditioningRecoBox CR,ForagingRecoBox FR,string outputfile);

LoadConfiguration::LoadConfiguration()
{

	w=700;
	setWindowTitle(tr("Run EthoLoop"));
	setWindowFlags ( Qt::CustomizeWindowHint | Qt::WindowTitleHint);

	QuestionPoints1 = new QGroupBox(tr("Load Configuration File"));
	QGridLayout *layout = new QGridLayout;
    BrowseButton = new QPushButton(tr("Browse"));
    LoadButton = new QPushButton(tr("Load"));
    QLabel *LabelInputFile = new QLabel(tr("Configuration File (.ini)"));
    lineEditLoading = new QLineEdit();

    layout->addWidget(LabelInputFile,1,0,1,1);
    layout->addWidget(lineEditLoading,1,1,1,1);
    layout->addWidget(BrowseButton,1,2,1,1);
    layout->addWidget(LoadButton,2,2,1,1);
 
    QuestionPoints1->setLayout(layout);


	QuestionPoints2 = new QGroupBox(tr(" "));
	QGridLayout *layout2 = new QGridLayout;
   	RunButton=new QPushButton(tr("RUN"));
	CancelButton=new QPushButton(tr("Cancel"));
    QLabel *Spacer = new QLabel(tr(" "));
	RunButton->setEnabled(false);
    
    layout2->addWidget(CancelButton,0,0);
    layout2->addWidget(Spacer,0,1,1,4);
    layout2->addWidget(RunButton,0,5);
   
    QuestionPoints2->setLayout(layout2);



	string defaultFilename="Tracking-"+currentDateTime();
    QString qstr = QString::fromStdString(defaultFilename);
    string path(getenv("HOME"));
    path=path+"/Desktop";
	QString defualtpath = QString::fromStdString(path);
	
	SavingDialog = new QGroupBox(tr("Save All Output Files"));
	QGridLayout *layout3 = new QGridLayout;
    BrowseButton2 = new QPushButton(tr("Browse"));
    QLabel *DirName = new QLabel(tr("Session Name"));
    QLabel *LabelOutputFolder = new QLabel(tr("Output Folder"));
    lineEditSaving = new QLineEdit(defualtpath);
    lineEditTrackingName=new QLineEdit(qstr);
    
    layout3->addWidget(DirName,0,0,1,1);
    layout3->addWidget(lineEditTrackingName,0,1,1,1);
    layout3->addWidget(LabelOutputFolder,1,0,1,1);
    layout3->addWidget(lineEditSaving,1,1,1,1);
    layout3->addWidget(BrowseButton2,1,2,1,1);
    
    SavingDialog->setLayout(layout3);


	mainLayout = new QGridLayout();
	mainLayout->addWidget(QuestionPoints1,0,0,2,2); //AskConfiguration Path
	mainLayout->addWidget(SavingDialog,5,0,1,2); 
	mainLayout->addWidget(QuestionPoints2,6,0,1,2); 
		
	connect(BrowseButton, SIGNAL (clicked()), this, SLOT (ChooseConfig()));
	connect(BrowseButton2, SIGNAL (clicked()), this, SLOT (ChooseDir()));
	connect(LoadButton, SIGNAL (clicked()), this, SLOT (CheckPath()));
	connect(RunButton, SIGNAL (clicked()), this, SLOT (StartEthoLoop()));
	connect(CancelButton, SIGNAL (clicked()), this, SLOT (close()));
		
	setLayout(mainLayout);
	setMinimumWidth(w);
	
	

}


void LoadConfiguration::ChooseConfig()
{
	string path(getenv("HOME"));
    path=path+"/Desktop";
	QString qstr = QString::fromStdString(path);
	QString QfileName = QFileDialog::getOpenFileName(this,tr("Choose a configuration file"), qstr, tr("txt files (*.ini)"));
	lineEditLoading->setText(QfileName);
}


void LoadConfiguration::CheckPath()
{
	ConfigPath=lineEditLoading->text().toStdString();
	ifstream checkfile(ConfigPath,ifstream::in);
	if(!checkfile.is_open()){
		QMessageBox msgBox;
		msgBox.setText("Can not load the file.Please check the path again.");
		msgBox.exec();
		return;
	}
	checkfile.close();
	
	if(Loaded==1){
		mainLayout->removeWidget(QuestionPoints3);
		QuestionPoints3->setParent(NULL);
	}
	AssigneInputs();
	DisplayGeneralInfo();
}


void LoadConfiguration::ChooseDir()
{
	string path(getenv("HOME"));
    path=path+"/Desktop";
	QString qstr = QString::fromStdString(path);
 	QString QfileName = QFileDialog::getExistingDirectory(this, tr("Open Directory"),qstr,QFileDialog::ShowDirsOnly| QFileDialog::DontResolveSymlinks);
	lineEditSaving->setText(QfileName);
}
	

void LoadConfiguration::AssigneInputs()
{
	
	Loaded=1;
	
	INIReader reader(ConfigPath);
	
	CAMNUM=reader.GetInteger("CamNum", "NUM", 0);
	
	ProjMat.clear();
	Ports.clear();
	IPs.clear();
	
	
	HostIP=reader.Get("Network_Information", "Host_IP", "UNKNOWN");
	cout<<HostIP<<endl;
	JetsonUsername=reader.Get("Network_Information", "JetsonsName", "UNKNOWN");
	JetsonPass=reader.Get("Network_Information", "JetsonsPass", "UNKNOWN");
	for(int i=0;i<CAMNUM;i++)
	{
		string jetsonid="Jetson_"+to_string(i+1)+"_IP_Port";
		string SS=reader.Get("Network_Information", jetsonid, "UNKNOWN");
		std::stringstream SS2(SS);
		string SIP;
		int IntPorts;
		SS2>>SIP>>IntPorts;
		IPs.push_back(SIP);
		Ports.push_back(IntPorts);	
	}
	

	for(int i=0;i<CAMNUM;i++){
		
	 	float Matrix[12];
		string Matrixname="M"+to_string(i);
		string SS=reader.Get("R_T", Matrixname, "UNKNOWN");
		std::stringstream SS2(SS);
    	for(int j=0;j<12;j++)
			SS2>>Matrix[j];
		Mat MM=Mat(3, 4, CV_32F, Matrix);	
		ProjMat.push_back(MM.clone());
	}

	float Matrix[12];
	string SS=reader.Get("RealWorld", "Real_R_T", "UNKNOWN");
	std::stringstream SS2(SS); 
    for(int i=0;i<12;i++)
		SS2>>Matrix[i];
	Mat RealM = cv::Mat(3, 4, CV_32F, Matrix);
	
	transfMatrix=RealM.clone();


	if(reader.HasSection("LiveCamera"))
	{
		UseLiveCamera=1;
		LC.Exposure=reader.GetInteger("LiveCamera", "Exposure", 10000);
		LC.Gain=reader.GetInteger("LiveCamera", "Gain", 0);
		string SS=reader.Get("LiveCamera", "Resolution", "UNKNOWN");
		std::stringstream SS2(SS);
		SS2>>LC.Width;
		SS2>>LC.Height;
	}
	
	if(reader.HasSection("CloseUp_System"))
	{
		UseCloseUp=1;
		CLUP.Exposure=reader.GetInteger("CloseUp_System", "Exposure", 10000);
		CLUP.Gain=reader.GetInteger("CloseUp_System", "Gain", 0);
		string SS=reader.Get("CloseUp_System", "Resolution", "UNKNOWN");
		std::stringstream SS2(SS);
		SS2>>CLUP.Width;
		SS2>>CLUP.Height;
		CLUP.OffsetZ=reader.GetInteger("CloseUp_System", "Z_Offset", 2048);
		CLUP.OffsetY=reader.GetInteger("CloseUp_System", "Y_Offset", 2048);
		SS=reader.Get("CloseUp_System", "Min_Max_Z", "UNKNOWN");
		std::stringstream SS3(SS);
		SS3>>CLUP.MinMaxZ[0]>>CLUP.MinMaxZ[1];
		SS=reader.Get("CloseUp_System", "Min_Max_Y", "UNKNOWN");
		std::stringstream SS4(SS);
		SS4>>CLUP.MinMaxY[0]>>CLUP.MinMaxY[1];
		SS=reader.Get("CloseUp_System", "CloseUp_Position", "UNKNOWN");
		std::stringstream SS5(SS);
		SS5>>CLUP.CL_Position.x>>CLUP.CL_Position.y>>CLUP.CL_Position.z;
		
	}
	
	if(reader.HasSection("RecoBoxConfiguration"))
	{
		UseRecoBox=1;
		string RecoMode=reader.Get("RecoBoxConfiguration", "Mode", "UNKNOWN");
		
		if(RecoMode=="Foraging")
		{
			RecoBoxMode=1;
			FR.RecoNums=reader.GetInteger("RecoBoxConfiguration", "Num_of_RecoBoxes", 0);
			FR.Port=reader.Get("RecoBoxConfiguration", "RecoBoxPort", "UNKNOWN");
			string foragingtype=reader.Get("RecoBoxConfiguration", "Type", "UNKNOWN");
			if(foragingtype=="Sequenced"){
				FR.ForagingSeq=reader.Get("RecoBoxConfiguration", "Sequence", "UNKNOWN");
				FR.ForagingType=0;
			}
			else
				FR.ForagingType=1;
				
			FR.Timeout=reader.GetInteger("RecoBoxConfiguration", "TimeOut", 0);
			FR.Repeat=reader.GetInteger("RecoBoxConfiguration", "RepeatFreq", 0);
			FR.RECO_Zone=reader.GetInteger("RecoBoxConfiguration", "RecoBoxZone", 0);
			string AllIPs=reader.Get("RecoBoxConfiguration","IP_Address", "UNKNOWN");
			string AllLocations=reader.Get("RecoBoxConfiguration", "Locations", "UNKNOWN");
			string AllStim=reader.Get("RecoBoxConfiguration", "Stimulus", "UNKNOWN");
			string AllRewSize=reader.Get("RecoBoxConfiguration", "RewardSize", "UNKNOWN");
			std::stringstream SSIP(AllIPs);
			std::stringstream SSLOC(AllLocations);
			std::stringstream SSStim(AllStim);
			std::stringstream SSRew(AllRewSize);
			for(int i=0;i<FR.RecoNums;i++)
			{
				SSIP>>FR.IP[i];
				SSLOC>>FR.SelfPos[i].x>>FR.SelfPos[i].y>>FR.SelfPos[i].z;
				SSStim>>FR.Stimulus[i];
				SSRew>>FR.RewardSize[i];
			}
		}
		
		if(RecoMode=="Conditioning")
		{
			RecoBoxMode=0;
			
			string conditioningtype=reader.Get("RecoBoxConfiguration", "Type", "UNKNOWN");
			
			if(conditioningtype=="Place")				
				CR.ConditioningType=0;
			else
			{
				CR.ConditioningType=1;
				CR.BehaviourPort=reader.Get("RecoBoxConfiguration", "BehaviorInfoPort", "UNKNOWN");
			}
			
			string S_SelfPos=reader.Get("RecoBoxConfiguration", "RecoBoxPosition", "UNKNOWN");
			std::stringstream SS_SelfPos(S_SelfPos);
			SS_SelfPos>>CR.SelfPos.x>>CR.SelfPos.y>>CR.SelfPos.z;
			
			string S_TargetPos=reader.Get("RecoBoxConfiguration", "TargetPosition", "UNKNOWN");
			std::stringstream SS_TargetPos(S_TargetPos);
			SS_TargetPos>>CR.TargetPos.x>>CR.TargetPos.y>>CR.TargetPos.z;
			
			CR.Port=reader.Get("RecoBoxConfiguration", "RecoBoxPort", "UNKNOWN");
			CR.IP=reader.Get("RecoBoxConfiguration", "RecoBoxIP", "UNKNOWN");
			CR.RECO_Zone=reader.GetInteger("RecoBoxConfiguration", "RecoBoxZone", 0);
			CR.Target_Zone=reader.GetInteger("RecoBoxConfiguration", "TargetZone", 0);
			CR.Timeout=reader.GetInteger("RecoBoxConfiguration", "TimeOut", 0);
			CR.RewardSize=reader.GetInteger("RecoBoxConfiguration", "RewardSize", 0);
			CR.Stimulus=reader.GetInteger("RecoBoxConfiguration", "Stimulus", 0);
			CR.Repeat=reader.GetInteger("RecoBoxConfiguration", "RepeatFreq", 0);
		}

	}
	SavingDir=lineEditSaving->text().toStdString() + "/"+lineEditTrackingName->text().toStdString();
	
}



void LoadConfiguration::DisplayGeneralInfo()
{
	string CamJetsonText="Number of JetsonTX2s: \t"+to_string(CAMNUM);
	string LiveCameraText="Use Live Camera: ";
	string CloseUpText="Use Close-up: ";
	string RecoBoxText="Use RECO-Box: ";
	string NO="\t\tNO";
	string YES="\t\tYES";
	string RECO_MODE_Text;
	
	if(UseRecoBox==1)RecoBoxText=RecoBoxText+YES;
	if(UseRecoBox==0)RecoBoxText=RecoBoxText+NO;
	
	if(UseRecoBox==1){
	 	cout<<CR.ConditioningType<<"d"<<endl;
		if(RecoBoxMode==0 & CR.ConditioningType==0)RecoBoxText=RecoBoxText+"\tPlace Conditioning ";
		if(RecoBoxMode==0 & CR.ConditioningType==1)RecoBoxText=RecoBoxText+"\tBehaviour Conditioning - Recieving Port: "+CR.BehaviourPort;
		if(RecoBoxMode==1 & FR.ForagingType==0 )RecoBoxText=RecoBoxText+"\tForaging mode - Sequence: "+FR.ForagingSeq;
		if(RecoBoxMode==1 & FR.ForagingType==1 )RecoBoxText=RecoBoxText+"\tForaging mode - Sequence:  Random";
	}

	if(UseLiveCamera==0)LiveCameraText=LiveCameraText+NO;
	if(UseLiveCamera==1)LiveCameraText=LiveCameraText+YES;
	
	if(UseCloseUp==0)CloseUpText=CloseUpText+NO;
	if(UseCloseUp==1)CloseUpText=CloseUpText+YES;
	
	QuestionPoints3 = new QGroupBox(tr(" "));
	QGridLayout *layout = new QGridLayout;
	
    QLabel *T1 = new QLabel(QString::fromStdString(CamJetsonText));
    QLabel *T2 = new QLabel(QString::fromStdString(LiveCameraText));
    QLabel *T3 = new QLabel(QString::fromStdString(CloseUpText));
    QLabel *T4 = new QLabel(QString::fromStdString(RecoBoxText));
	NetworkConnection=new QPushButton(tr("Connect to Jetsons"));
    connect(NetworkConnection, SIGNAL (clicked()), this, SLOT (RunJetsons()));
    
    layout->addWidget(T1,0,0,1,2);
    layout->addWidget(NetworkConnection,0,2,1,1);
    layout->addWidget(T2,1,0,1,2);
    layout->addWidget(T3,2,0,1,2);
    layout->addWidget(T4,3,0,1,2);

    QuestionPoints3->setLayout(layout);
    mainLayout->addWidget(QuestionPoints3,3,0,1,2); 
}



void LoadConfiguration::RunJetsons()
{
	if(JetsonsRunning==0){
	
		NetworkConnection->setText("Connecting ....");
		QApplication::processEvents();
		//Run all the jetsons
		for(int i =0;i<CAMNUM;i++)
		{
			string ip=IPs[i];
			string recport=to_string(Ports[i]);
			string hostip=HostIP;
			string loginCmd="konsole -e sshpass -p "+JetsonPass+" ssh -o StrictHostKeyChecking=no -t "+JetsonUsername +"@"+ip;
			string ProcCmd=" \"echo "+JetsonPass+" | sudo -S ./Desktop/cpu_gpu.sh ;  sudo   ./Desktop/SingleLEDTrack/M "+hostip+" "+ recport +"  900000 \"";
			string FinalCmd=loginCmd+ProcCmd;
			system(FinalCmd.c_str());
		}
		JetsonsRunning=1;
		NetworkConnection->setText("Close All Connections");
		RunButton->setEnabled(true);
		
	}
	
	else{
		system("pkill konsole");
		NetworkConnection->setText("Connect to Jetsons");
		JetsonsRunning=0;
		RunButton->setEnabled(false);
	}
		
}


void LoadConfiguration::StartEthoLoop() 	
{
	string CreatOutputDirectory="mkdir "+SavingDir;
	string CopyConfigFile="cp "+ConfigPath+" "+SavingDir;
	system(CreatOutputDirectory.c_str());
	system(CopyConfigFile.c_str());
	
	RunEthoLoop(CAMNUM, ProjMat, transfMatrix, Ports, UseLiveCamera, LC, UseCloseUp, CLUP, UseRecoBox, RecoBoxMode,CR, FR ,SavingDir);
	close();
	sleep(1);
	//TrackDone.store(true);
}







