#ifndef LOADCONFIGURATION_H
#define LOADCONFIGURATION_H

#include <QApplication>
#include <QPushButton>
#include <QProgressBar>

#include <QSlider>
#include <QtWidgets/QApplication>
#include <QPushButton>

#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <QInputDialog>
#include <QDir>
#include <QFormLayout>
#include  <QLayout>

#include  <QGroupBox>
#include <QMainWindow>


#include <QTextEdit>
#include <QDialogButtonBox>
#include <QtWidgets/QLabel>
#include <QMenuBar>
#include <QSpinBox>
#include <QComboBox>
#include <QCheckBox>
#include <QSlider>


#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "opencv2/opencv.hpp"

using namespace std;
using namespace cv;
extern int IterNum;

class LiveCamera {
  public:
  	int Exposure;
  	int Gain;
  	int Width;
  	int Height;
};
class ConditioningRecoBox {
  public:
  	Point3f SelfPos;
  	Point3f TargetPos;
  	string IP;
  	string Port;
  	string Stimulus;
  	int RECO_Zone;
  	int Target_Zone;
  	int Repeat;
  	int Timeout;
  	int RewardSize;
  	int ConditioningType;
  	string BehaviourPort;
};

class ForagingRecoBox {
  public:
  	int	RecoNums;
  	string ForagingSeq;
  	Point3f SelfPos[9];
  	string IP[9];
  	string Port;
  	int RECO_Zone;
  	int Repeat;
  	int Timeout;
  	int RewardSize[9];
  	string Stimulus[9];
  	int ForagingType;
};

class CloseUpSystem {
  public:
	int Exposure;
	int Gain;
	int Width;
	int Height;
	int OffsetZ;
	int OffsetY;
	int MinMaxZ[2];
	int MinMaxY[2];
	Point3f CL_Position;
};


class LoadConfiguration : public QDialog
{
    
Q_OBJECT

public:
	
	LoadConfiguration();
	
	vector <string> IPs;
	vector <int> Ports;
	string JetsonUsername;
	string JetsonPass;
	string HostIP;
	LiveCamera LC;
	ForagingRecoBox FR;
	ConditioningRecoBox CR;
	CloseUpSystem CLUP;
    
    string ConfigPath;
    int Loaded=0;
    int JetsonsRunning=0;
   	int CAMNUM;
   	vector<Mat> ProjMat;
   	Mat transfMatrix;
   	int UseLiveCamera;
	int UseRecoBox;
	int UseCloseUp;
	int RecoBoxMode;
	string SavingDir;

private:
	QGridLayout *mainLayout;

	QGroupBox *QuestionPoints1;
	QPushButton *BrowseButton;
	QPushButton *NetworkConnection;
	QPushButton *LoadButton;
	QLineEdit *lineEditLoading;
	
	QGroupBox *QuestionPoints2;
	QGroupBox *QuestionPoints3;
	QPushButton *RunButton;
	QPushButton *CancelButton;
	
	QGroupBox *SavingDialog;
	QPushButton *BrowseButton2;
	QLineEdit *lineEditSaving;
	QLineEdit *lineEditTrackingName;
	
public slots:
    	void ChooseConfig();
    	void CheckPath();
    	void AssigneInputs();
    	void DisplayGeneralInfo();
    	void RunJetsons();
    	void StartEthoLoop();  
    	void ChooseDir();
};

#endif // WINDOW_H
