#include <QApplication>
#include "ManualRecoBox.h"
#include <QPushButton>
#include <QProgressBar>
#include <QSlider>
#include <QtWidgets/QApplication>
#include <QPushButton>
#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <QInputDialog>
#include <QDir>
#include <QFormLayout>
#include  <QLayout>
#include  <QGroupBox>
#include <QMainWindow>
#include <QTextEdit>
#include <QDialogButtonBox>
#include <QtWidgets/QLabel>
#include <QMenuBar>
#include <QSpinBox>
#include<QComboBox>
#include <QScrollArea>
#include <QCheckBox>

#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <QFileDialog>
#include <QMessageBox>

#include <iomanip>
#include <unistd.h>
#include <arpa/inet.h>
#include <fstream>
#include "opencv2/opencv.hpp"
#include <chrono>
#include <atomic>

using namespace std;
using namespace cv;

extern int w;
extern int RecoConnection(string IP, string port);
extern void SendCommand(string command);


ManualRecoBox::ManualRecoBox()
{

	w=500;
	RecoPort=tr("2390");
	for(int i=0;i<9;i++)
		IP[i]=tr("10.0.0.20%1").arg(i + 1);
	
	setWindowTitle(tr("Control RECO-Box"));
	//setWindowFlags ( Qt::CustomizeWindowHint | Qt::WindowTitleHint);
	InfoPage(RecoNumbers);
	ControlPage();
	AdjustmentPage(RecoNumbers);

	mainLayout = new QGridLayout();
	mainLayout->addWidget(QuestionPoints1,0,0); //AskConfiguration Path
	mainLayout->addWidget(QuestionPoints3,2,0); 
		
	setLayout(mainLayout);
	setMinimumWidth(w);
	
}

void ManualRecoBox::InfoPage(int Num)  
{
	QuestionPoints1 = new QGroupBox(tr("RECO-Box Information"));
	QGridLayout *layout = new QGridLayout;
    AdjustButton = new QPushButton(tr("Adjust IPs"));
    QLabel *RNUM=new QLabel(tr("Reco-Box Number"));
    RecoID = new QSpinBox;
   	QLabel *OutOf=new QLabel(tr("/%1").arg(Num));
   	RNUM->setAlignment(Qt::AlignRight|Qt::AlignVCenter);
   	
   	RecoID->setValue(1);
    RecoID->setMaximum(Num);
    RecoID->setMinimum(1);
    RecoConnection(IP[0].toStdString(), RecoPort.toStdString());
    
    
    layout->addWidget(AdjustButton,1,0,1,2);
    layout->addWidget(RNUM,1,2,1,3);
    layout->addWidget(RecoID,1,5,1,1);
    layout->addWidget(OutOf,1,6,1,1);
   	
   	connect(RecoID, static_cast<void (QSpinBox::*)(int)>(&QSpinBox::valueChanged),this, [=]() { int ID=RecoID->value(); RecoConnection(IP[ID-1].toStdString(),RecoPort.toStdString()); });
   	connect(AdjustButton, SIGNAL (clicked()), this, SLOT (GoToAdjustmentPage()));
    QuestionPoints1->setLayout(layout);

}

void ManualRecoBox::ControlPage()
{

	QuestionPoints3 = new QGroupBox(tr("Control Panel"));
	QGridLayout *layout = new QGridLayout;
	
	Click = new QPushButton(tr("Click"));
	Buzzer = new QPushButton(tr("Buzzer"));
	GreenLED = new QPushButton(tr("GreenLED"));
	IRLED = new QPushButton(tr("IR LED"));
	Reward = new QPushButton(tr("Reward"));
	QLabel *Freq=new QLabel(tr("KHz"));
	QLabel *RSize=new QLabel(tr("nl"));
	Freq->setAlignment(Qt::AlignLeft|Qt::AlignVCenter);
	RSize->setAlignment(Qt::AlignLeft|Qt::AlignVCenter);
	BuzzerFreq=new QSpinBox;
	RewSize=new QSpinBox;
	
	BuzzerFreq->setValue(1);
    BuzzerFreq->setMaximum(20);
    BuzzerFreq->setMinimum(1);
    
    RewSize->setValue(100);
    RewSize->setMaximum(1000);
    RewSize->setMinimum(100);
	
	layout->addWidget(Click,1,0,1,10);
    layout->addWidget(Buzzer,1,10,1,8);
    layout->addWidget(BuzzerFreq,1,18,1,1);
    layout->addWidget(Freq,1,19,1,1);
    
    layout->addWidget(GreenLED,2,0,1,10);
    layout->addWidget(Reward,2,10,1,8);
    layout->addWidget(RewSize,2,18,1,1);
    layout->addWidget(RSize,2,19,1,1);
    
    layout->addWidget(IRLED,3,0,1,10);
    
	connect(Click, &QPushButton::clicked, Click, [=]() { SendCommand("p"); });
	connect(Buzzer, &QPushButton::clicked, Buzzer, [=]() { SendCommand("b"+to_string(BuzzerFreq->value())); });
	connect(IRLED, &QPushButton::clicked, IRLED, [=]() { SendCommand("i"); });
	connect(GreenLED, &QPushButton::clicked, GreenLED, [=]() { SendCommand("g"); });
	connect(Reward, &QPushButton::clicked, Reward, [=]() { SendCommand("m"+to_string(RewSize->value())); });
  	       
    QuestionPoints3->setLayout(layout);
}

void ManualRecoBox::AdjustmentPage(int Num)
{
	QuestionPoints2 = new QGroupBox(tr("Configure RECO-Boxes"));
	QGridLayout *layout = new QGridLayout;
	
	QLabel *LabelRecosNum=new QLabel(tr("Number of RECO-Boxes"));
	LabelRecosNum->setAlignment(Qt::AlignRight|Qt::AlignVCenter);
	AdjustRecoNums=new QSpinBox;
	lineEditPort=new QLineEdit(RecoPort);
	QLabel *PortLabel=new QLabel(tr("Reco Port"));
	PortLabel->setAlignment(Qt::AlignRight|Qt::AlignVCenter);
	ApplyButton=new QPushButton(tr("Apply"));
	
	
	AdjustRecoNums->setValue(Num);
	AdjustRecoNums->setMaximum(9);
    AdjustRecoNums->setMinimum(1);
	

	layout->addWidget(LabelRecosNum,0,0,1,2);
	layout->addWidget(AdjustRecoNums,0,2,1,1);
	
	QLabel *Spacer1=new QLabel(tr(""));
	layout->addWidget(Spacer1,1,0);
	
	layout->addWidget(PortLabel,2,0,1,2);
	layout->addWidget(lineEditPort,2,2,1,1);
	
	QLabel *Spacer2=new QLabel(tr(""));
	layout->addWidget(Spacer2,3,0);
	
	QLabel *AllLabels[Num];
	
	for(int i=0;i<Num;i++){
    	AllLabels[i]=new QLabel(tr("RECO-Box %1 IP").arg(i + 1));
    	AllLabels[i]->setAlignment(Qt::AlignRight|Qt::AlignVCenter);
    	lineEditIPs[i] = new QLineEdit(IP[i]);
    	layout->addWidget(AllLabels[i],i+4,0,1,2);
    	layout->addWidget(lineEditIPs[i],i+4,2,1,1);
    }


	layout->addWidget(ApplyButton,Num+4,4);
	
	
    connect(AdjustRecoNums, static_cast<void (QSpinBox::*)(int)>(&QSpinBox::valueChanged),this, &ManualRecoBox::AddRemoveRecoBox);
    connect(ApplyButton, SIGNAL (clicked()), this, SLOT (ApplyAdjustments()));
    QuestionPoints2->setLayout(layout);

}


void ManualRecoBox::AssigneInputs()
{
	
	RecoPort=lineEditPort->text();
	for(int i=0;i<RecoNumbers;i++)
		IP[i]=lineEditIPs[i]->text();

}

void ManualRecoBox::AddRemoveRecoBox()
{
	AssigneInputs();
	RecoNumbers = AdjustRecoNums->value();
	mainLayout->removeWidget(QuestionPoints2);	
	adjustSize();
	QuestionPoints2->setParent(NULL);
	AdjustmentPage(RecoNumbers);
	mainLayout->addWidget(QuestionPoints2,0,0);	
}

void ManualRecoBox::GoToAdjustmentPage()
{
	mainLayout->removeWidget(QuestionPoints1);	
	mainLayout->removeWidget(QuestionPoints3);
	QuestionPoints1->setParent(NULL);
	QuestionPoints3->setParent(NULL);
	AdjustmentPage(RecoNumbers);
	mainLayout->addWidget(QuestionPoints2,0,0);	
	adjustSize();	
}

void ManualRecoBox::ApplyAdjustments()
{
		AssigneInputs();
		InfoPage(RecoNumbers);
		ControlPage();
		mainLayout->removeWidget(QuestionPoints2);
		QuestionPoints2->setParent(NULL);
		mainLayout->addWidget(QuestionPoints1,0,0); //AskConfiguration Path
		mainLayout->addWidget(QuestionPoints3,2,0); 
		adjustSize();
}

void ManualRecoBox::CommandRecoBox(int cm)
{
	cout<<"hi"<<endl;
}
