#include <QApplication>
#include "SetUpConfiguration.h"
#include <QPushButton>
#include <QProgressBar>
#include <QSlider>
#include <QtWidgets/QApplication>
#include <QPushButton>
#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <QInputDialog>
#include <QDir>
#include <QFormLayout>
#include  <QLayout>
#include  <QGroupBox>
#include <QMainWindow>
#include <QTextEdit>
#include <QDialogButtonBox>
#include <QtWidgets/QLabel>
#include <QMenuBar>
#include <QSpinBox>
#include<QComboBox>
#include <QScrollArea>
#include <QCheckBox>

#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <QFileDialog>
#include <QMessageBox>

#include <iomanip>
#include <unistd.h>
#include <arpa/inet.h>
#include <fstream>
#include "opencv2/opencv.hpp"
#include <chrono>

using namespace std;


extern int w;
extern string currentDateTime();
int HasLiveView=0;
int HasRecoBox=0;
int HasCloseUp=0;
SetUpConfiguration::SetUpConfiguration()
{
	
	ForagingRecoNumbers=4;
	
	for(int i=0;i<9;i++)
	{
		F_Reco.SelfPos[i]=tr("10 110 20");
		F_Reco.IP[i]=tr("10.0.0.20%1").arg(i + 1);
		F_Reco.BeepFreq[i]=9;
		F_Reco.RewardSize[i]=100;
		F_Reco.Stimulus[i]=0;
	}
	
	
	w=1000;
	setWindowTitle(tr("Create Configuration File"));
	setWindowFlags ( Qt::CustomizeWindowHint | Qt::WindowTitleHint);
	
	LiveCameraParams C;
	HoldCheckVal=1;
	HoldCheckVal2=1;
	HoldCheckValClose=1;
	RecoBoxMode=0;
	RecoBoxSubMode=0;


	
	LoadMatrix();
	OutputConfigFile();
	FinishedButton();
	checkbox = new QCheckBox("Live View Camera",this);
	checkbox->setChecked(false);
	checkboxClose = new QCheckBox("Close Up View",this);
	checkboxClose->setChecked(false);
	checkbox2 = new QCheckBox("Use RECO-Box",this);
	checkbox2->setChecked(false);

	mainLayout = new QGridLayout();
	mainLayout->addWidget(QuestionPoints1,0,0,2,2); //AskCalibration Path
	mainLayout->addWidget(checkbox,2,0,1,1);
	mainLayout->addWidget(checkboxClose,5,0,1,1);
	mainLayout->addWidget(checkbox2,8,0,1,1);
	
	mainLayout->addWidget(QuestionPoints4,12,0,1,2);
	mainLayout->addWidget(QuestionPoints5,13,0,1,2);
	
	connect(BrowseButton, SIGNAL (clicked()), this, SLOT (ChooseCalibrationConfig()));
	connect(SavingConfigButton, SIGNAL (clicked()), this, SLOT (SaveTheConfigFile()));
	connect(CancelConfigButton, SIGNAL (clicked()), this, SLOT(close()));
	connect(ChooseOutPutPath, SIGNAL (clicked()), this, SLOT (ChooseSaveDirConfiguration()));
	connect(checkbox,  &QCheckBox::stateChanged ,this, &SetUpConfiguration::LiveClicked);
	connect(checkbox2, &QCheckBox::stateChanged ,this, &SetUpConfiguration::RecoBoxClicked);
	connect(checkboxClose, &QCheckBox::stateChanged ,this, &SetUpConfiguration::CloseUpClicked);
	
	setLayout(mainLayout);
	setMinimumWidth(w);
	
	
	//for creating the layout for parsing the assign file
	
	LoadRECOBox(1,0);
	LoadRECOBox(0,1);
	LoadRECOBox(1,1);
	LoadRECOBox(0,0);
	LoadLiveCamera();
	LoadCloseUp();
	////////////////////////////////
}



void SetUpConfiguration::LoadMatrix()
{

	QuestionPoints1 = new QGroupBox(tr("Load Calibration File"));
	QGridLayout *layout = new QGridLayout; 
    BrowseButton = new QPushButton(tr("Browse"));
    QLabel *LabelInputFile = new QLabel(tr("Calibration File (.ini)"));
    lineEditLoading = new QLineEdit();

    layout->addWidget(LabelInputFile,1,0,1,1);
    layout->addWidget(lineEditLoading,1,1,1,1);
    layout->addWidget(BrowseButton,1,2,1,1);
    
    QuestionPoints1->setLayout(layout);
}


void SetUpConfiguration::ChooseCalibrationConfig()
{
	string path(getenv("HOME"));
    path=path+"/Desktop";
	QString qstr = QString::fromStdString(path);
	QString QfileName = QFileDialog::getOpenFileName(this,tr("Choose a config file"), qstr, tr("txt files (*.ini)"));
	lineEditLoading->setText(QfileName);
}
void SetUpConfiguration::ChooseSaveDirConfiguration()
{
	string path(getenv("HOME"));
    path=path+"/Desktop";
	QString qstr = QString::fromStdString(path);
 	QString QfileName = QFileDialog::getExistingDirectory(this, tr("Open Directory"),qstr,QFileDialog::ShowDirsOnly| QFileDialog::DontResolveSymlinks);
	lineEditSavingConfig->setText(QfileName);
}

void SetUpConfiguration::LoadLiveCamera()
{
	
	QuestionPoints2 = new QGroupBox(tr("Live Image Parameters"));
   	QGridLayout *layout= new QGridLayout;
    LiveCameraExposure = new QSpinBox;
    LiveCameraGain = new QSpinBox;
    LiveCameraResolutionW=new QSpinBox;
	LiveCameraResolutionH=new QSpinBox;
    
    LiveCameraExposure->setMaximum(50000);
    LiveCameraExposure->setMinimum(50);
    LiveCameraGain->setMaximum(20);
    LiveCameraGain->setMinimum(0);
    LiveCameraResolutionW->setMaximum(2000);
    LiveCameraResolutionW->setMinimum(100);
    LiveCameraResolutionH->setMaximum(2000);
    LiveCameraResolutionH->setMinimum(100);

   	
    layout->addWidget(new QLabel(tr("   Exposure(ns):")),1,0,1,3);
   	layout->addWidget(LiveCameraExposure,1,3,1,2);
    
   	layout->addWidget(new QLabel(tr("   Gain")),1,6,1,2);
   	layout->addWidget(LiveCameraGain,1,8);
  
   	layout->addWidget(new QLabel(tr("      Resolution")),1,10,1,3);
   	layout->addWidget(LiveCameraResolutionW,1,13);
   	layout->addWidget(new QLabel(tr("X")),1,14);
   	layout->addWidget(LiveCameraResolutionH,1,15);
   	
   	
	LiveCameraExposure->setValue(LiveCamera.Exposure);
	LiveCameraResolutionW->setValue(LiveCamera.Width);
	LiveCameraResolutionH->setValue(LiveCamera.Height);
	LiveCameraGain->setValue(LiveCamera.Gain);

    QuestionPoints2->setLayout(layout);
}



void SetUpConfiguration::LoadCloseUp()
{
	

	
	QuestionPointsClose = new QGroupBox(tr("Close-Up Parameters"));
   	QGridLayout *layout= new QGridLayout;
    CloseExposure = new QSpinBox;
    CloseGain = new QSpinBox;
    CloseResolutionW=new QSpinBox;
	CloseResolutionH=new QSpinBox;
    CloseOffsetZ=new QSpinBox;
	CloseOffsetY=new QSpinBox;
	
	MinZ= new QSpinBox;
	MinY= new QSpinBox;
	MaxZ= new QSpinBox;
	MaxY= new QSpinBox;

	lineEditClosePosition=new QLineEdit;
	
    CloseExposure->setMaximum(50000);
    CloseExposure->setMinimum(50);
    CloseGain->setMaximum(20);
    CloseGain->setMinimum(0);
    CloseResolutionW->setMaximum(2000);
    CloseResolutionW->setMinimum(100);
    CloseResolutionH->setMaximum(2000);
    CloseResolutionH->setMinimum(100);
	CloseOffsetZ->setMaximum(4096);
	CloseOffsetY->setMaximum(4096);
	MinZ->setMaximum(4080);
	MinY->setMaximum(4080);
	MaxZ->setMaximum(4080);
	MaxY->setMaximum(4080);
	
	
	layout->addWidget(new QLabel(tr("  3D Position")),0,0,1,3);
   	layout->addWidget(lineEditClosePosition,0,3,1,3);
	
	layout->addWidget(new QLabel(tr("  Z Axis Offset:")),1,0,1,3);
   	layout->addWidget(CloseOffsetZ,1,3,1,2);
   	
   	layout->addWidget(new QLabel(tr("Min Max Ranges")),1,5,1,3);
   	layout->addWidget(MinZ,1,8,1,1);
   	layout->addWidget(MaxZ,1,9,1,1);

	layout->addWidget(new QLabel(tr("  Y Axis Offset:")),1,10,1,3);
   	layout->addWidget(CloseOffsetY,1,13,1,2);
   	
   	layout->addWidget(new QLabel(tr("Min Max Ranges")),1,15,1,3);
   	layout->addWidget(MinY,1,18,1,1);
   	layout->addWidget(MaxY,1,19,1,1);
   	
   




    layout->addWidget(new QLabel(tr("   Exposure(ns):")),2,0,1,3);
   	layout->addWidget(CloseExposure,2,3,1,2);
    
   	layout->addWidget(new QLabel(tr("   Gain")),2,6,1,2);
   	layout->addWidget(CloseGain,2,8);
  
   	layout->addWidget(new QLabel(tr("      Resolution")),2,10,1,3);
   	layout->addWidget(CloseResolutionW,2,13);
   	layout->addWidget(new QLabel(tr("X")),2,14);
   	layout->addWidget(CloseResolutionH,2,15);

	CloseExposure->setValue(CLUP.Exposure);
	CloseResolutionW->setValue(CLUP.Width);
	CloseResolutionH->setValue(CLUP.Height);
	CloseGain->setValue(CLUP.Gain);
	CloseOffsetZ->setValue(CLUP.OffsetZ);
	CloseOffsetY->setValue(CLUP.OffsetY);
	lineEditClosePosition->setText(CLUP.CL_Position);
	
	MinZ->setValue(CLUP.MinMaxZ[0]);
	MaxZ->setValue(CLUP.MinMaxZ[1]);
	MinY->setValue(CLUP.MinMaxY[0]);
	MaxY->setValue(CLUP.MinMaxY[1]);
	  	
    QuestionPointsClose->setLayout(layout);
}



void SetUpConfiguration::LoadRECOBox(int mode,int submode){

	QuestionPoints3 = new QGroupBox(tr("Reco-Box"));
   	QGridLayout *layout= new QGridLayout;
 	RecoMode = new QComboBox;
    RecoMode->addItem(tr("Conditioning"));
    RecoMode->addItem(tr("  Foraging  "));
    
   
    	
    RecoMode->setCurrentIndex(mode);
    layout->addWidget(new QLabel(tr("Type of Experiment")),0,0,1,2);
    layout->addWidget(RecoMode,0,2,1,2);
   
    layout->addWidget(new QLabel(tr(" ")),1,0);//adding space
    if(mode==0)
    {
    	
    	ConditioningState = new QComboBox;
    	ConditioningState->addItem(tr("   Place   "));
    	ConditioningState->addItem(tr("  Behaviour"));
    	ConditioningState->setCurrentIndex(submode);
    	
    	ReceivingBehaviorPort=new QSpinBox;
    	lineEditConditioningIP=new QLineEdit;
    	lineEditConditioningIP->setInputMask("000.000.000.000");
    	lineEditConditioningIP->setAlignment(Qt::AlignCenter|Qt::AlignVCenter);
    	ConditioningRecoPort=new QSpinBox;
    	
    	ConditioningRewardZone=new QSpinBox;
    	lineEditConditioningPlace=new QLineEdit;
    	ConditioningTimeOut=new QSpinBox;
    	ConditioningZoneSpace=new QSpinBox;
    	lineEditConditioningRecoLocation=new QLineEdit;
    	
    	lineEditConditioningIP->setText(tr("10.0.0.201"));
    	StimulusMode = new QComboBox;
    	StimulusMode->addItem(tr("Buzzer"));
    	StimulusMode->addItem(tr("Click"));
    	StimulusMode->addItem(tr("LED"));
    	StimulusMode->addItem(tr("White Noise"));
    	ConditioningBuzzFreq=new QSpinBox;
    	ConditioningRepeatFreq=new QSpinBox;
    	ConditioningRewardSize=new QSpinBox;
    	
    	ConditioningRecoPort->setMaximum(9999);
    	ConditioningRecoPort->setMinimum(1111);
    	ReceivingBehaviorPort->setMaximum(9999);
    	ReceivingBehaviorPort->setMinimum(1111);
		ConditioningRepeatFreq->setMaximum(99);	
		ConditioningTimeOut->setMaximum(99);
		ConditioningRewardSize->setMaximum(1000);		
		ConditioningBuzzFreq->setMaximum(20);
		ConditioningZoneSpace->setMaximum(99);		
		ConditioningRewardZone->setMaximum(99);
    	
    	int LabelNumbers=11;
    	QString LabelStrings[LabelNumbers]={tr("RECO-Box IP address"),tr("Port"),tr("RECO-Box 3D location"),tr("Zone(cm)"),tr("Target Location"),tr("Zone(cm)"),
    	tr("Stimulus"),tr("Freq(KHz)"),tr("Repeat(s)"),tr("Reward size(nl)"),tr("Time out(s)")};		
    	QLabel *Label[LabelNumbers];
    	for(int i=0;i<LabelNumbers;i++)
    	{
    		Label[i]=new QLabel(LabelStrings[i]);
    		//Label[i]->setAlignment(Qt::AlignRight|Qt::AlignVCenter);
    	}
    	
    	
    	layout->addWidget(ConditioningState,0,4,1,2);
    	
    	 if(mode==0 & submode==1)
    	 {
    	 	QLabel *BehaviourLabel=new QLabel(tr("Recieving info from port "));
    	 	BehaviourLabel->setAlignment(Qt::AlignRight|Qt::AlignVCenter);
    	 	layout->addWidget(BehaviourLabel,0,6,1,3);
    		layout->addWidget(ReceivingBehaviorPort,0,9,1,1);
    	 }
    	 	
    	
    	layout->addWidget(Label[0],2,0,1,2);
    	layout->addWidget(lineEditConditioningIP,2,2,1,2);
    	
    	layout->addWidget(Label[1],2,4,1,1);
    	layout->addWidget(ConditioningRecoPort,2,5,1,1);
    	
    	layout->addWidget(Label[2],3,0,1,2);
    	layout->addWidget(lineEditConditioningRecoLocation,3,2,1,2);
    	layout->addWidget(Label[3],3,4);
    	layout->addWidget(ConditioningRewardZone,3,5);
    	layout->addWidget(Label[4],3,6,1,2);
    	layout->addWidget(lineEditConditioningPlace,3,8,1,2);
		layout->addWidget(Label[5],3,10);
    	layout->addWidget(ConditioningZoneSpace,3,11);
    	
    	layout->addWidget(Label[6],4,0);
    	layout->addWidget(StimulusMode,4,1);
    	layout->addWidget(Label[7],4,2);
    	layout->addWidget(ConditioningBuzzFreq,4,3);
    	
    	layout->addWidget(Label[8],4,4);
    	layout->addWidget(ConditioningRepeatFreq,4,5);
    	layout->addWidget(Label[9],4,6,1,2);
    	layout->addWidget(ConditioningRewardSize,4,8,1,1);
    	layout->addWidget(Label[10],4,9,1,1);
    	layout->addWidget(ConditioningTimeOut,4,10);
    	connect(StimulusMode, static_cast<void (QComboBox::*)(int)>(&QComboBox::currentIndexChanged),this,
    	[=](int index){ if(index==0)ConditioningBuzzFreq->setEnabled(true);else ConditioningBuzzFreq->setEnabled(false); });
    	 
		lineEditConditioningIP->setText(C_Reco.IP);
		lineEditConditioningPlace->setText(C_Reco.TargetPos);
		lineEditConditioningRecoLocation->setText(C_Reco.SelfPos);
		ConditioningRewardZone->setValue(C_Reco.RECO_Zone);
		ConditioningZoneSpace->setValue(C_Reco.Target_Zone);
		ConditioningBuzzFreq->setValue(C_Reco.BeepFreq);
		ConditioningRewardSize->setValue(C_Reco.RewardSize);
		ConditioningTimeOut->setValue(C_Reco.Timeout);
		ConditioningRepeatFreq->setValue(C_Reco.Repeat);
		StimulusMode->setCurrentIndex(C_Reco.ConditioningStumulus);
		ConditioningRecoPort->setValue(C_Reco.Port);
		ReceivingBehaviorPort->setValue(C_Reco.BehaviorPort);
		
		connect(ConditioningState, static_cast<void (QComboBox::*)(int)>(&QComboBox::currentIndexChanged),this,&SetUpConfiguration::RecoModeChanged);
		
    }
   	if(mode==1)
  	{	
  		
  		ForagingState = new QComboBox;
    	ForagingState->addItem(tr("Sequenced"));
    	ForagingState->addItem(tr("  Random "));
    	ForagingState->setCurrentIndex(submode);
  		
  		
  		int LabelNumbers=6;
    	QString LabelStrings[LabelNumbers]={tr("Number of RECO-Boxes"),tr("Foraging Sequence"),tr("Zone(cm)"),tr("Repeat(s)"),tr("Time out"),tr("Port")};	
    	QLabel *Label[LabelNumbers];
    	for(int i=0;i<LabelNumbers;i++)
    	{
    		Label[i]=new QLabel(LabelStrings[i]);
    		Label[i]->setAlignment(Qt::AlignRight|Qt::AlignVCenter);
    	}
  		RecoBoxNumbers=new QSpinBox;
  		ForagingTimeOut=new QSpinBox;
  		ForagingRecoZone=new QSpinBox;
  		ForagingRepeatFreq=new QSpinBox;
  		ForagingRecoPort=new QSpinBox;
  		
  		RecoBoxNumbers->setMaximum(9);
  		ForagingRecoZone->setMaximum(99);
  		ForagingRepeatFreq->setMaximum(99);
  		ForagingTimeOut->setMaximum(99);
  		ForagingRecoPort->setMaximum(9999);
    	ForagingRecoPort->setMinimum(1111);
  		RecoBoxNumbers->setValue(ForagingRecoNumbers);
  		F_Reco.ForagingSeq=tr("");
  		for(int i=0;i<ForagingRecoNumbers;i++)
			F_Reco.ForagingSeq=F_Reco.ForagingSeq+tr("%1").arg(i + 1);
			
  		lineEditForagingSequence=new QLineEdit(F_Reco.ForagingSeq);
  		lineEditForagingSequence->setInputMask("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 ");
  		lineEditForagingSequence->setAlignment(Qt::AlignCenter|Qt::AlignVCenter);
  		
  		layout->addWidget(ForagingState,0,4,1,2);
  		
    	layout->addWidget(Label[0],2,0,1,2);
    	layout->addWidget(RecoBoxNumbers,2,2,1,1);
    	layout->addWidget(Label[1],2,3,1,2);
    	layout->addWidget(lineEditForagingSequence,2,5,1,3);
    	layout->addWidget(Label[2],3,0,1,1);
    	layout->addWidget(ForagingRecoZone,3,1,1,1);
    	layout->addWidget(Label[3],3,2,1,1);
    	layout->addWidget(ForagingRepeatFreq,3,3,1,1);
    	layout->addWidget(Label[4],3,4,1,1);
    	layout->addWidget(ForagingTimeOut,3,5,1,1);
    	layout->addWidget(Label[5],3,6,1,1);
    	layout->addWidget(ForagingRecoPort,3,7,1,1);
    	
    	
    	
    	for(int i=0;i<ForagingRecoNumbers;i++)
    	{
    	
    		QLabel *AllLabels[5];
    		AllLabels[0]=new QLabel(tr("%1. IP").arg(i + 1));
    		AllLabels[1]=new QLabel(tr("Location"));
    		AllLabels[2]=new QLabel(tr("Stimulus"));
    		AllLabels[3]=new QLabel(tr("Freq (KHz)"));
    		AllLabels[4]=new QLabel(tr("Reward (nl)"));
    		for(int i=0;i<5;i++)
    			AllLabels[i]->setAlignment(Qt::AlignRight|Qt::AlignVCenter);
    		lineEditForagingIPs[i]=new QLineEdit(F_Reco.IP[i]);
    		lineEditForagingLocations[i]=new QLineEdit(F_Reco.SelfPos[i]);
    		Stimulus[i] = new QComboBox;
    		Stimulus[i]->addItem(tr("Buzzer"));
    		Stimulus[i]->addItem(tr("Click"));
    		Stimulus[i]->addItem(tr("LED"));
    		Stimulus[i]->addItem(tr("White Noise"));
    		
    		StimulFrequency[i]=new QSpinBox;
    		RewardSize[i]=new QSpinBox;
    		
    		layout->addWidget(AllLabels[0],4+i,0,1,1);
    		layout->addWidget(lineEditForagingIPs[i],4+i,1,1,2);
    		layout->addWidget(AllLabels[1],4+i,3,1,1);
    		layout->addWidget(lineEditForagingLocations[i],4+i,4,1,2);
    		layout->addWidget(AllLabels[2],4+i,6,1,1);
    		layout->addWidget(Stimulus[i],4+i,7,1,1);
    		layout->addWidget(AllLabels[3],4+i,8,1,1);
    		layout->addWidget(StimulFrequency[i],4+i,9,1,1);
    		layout->addWidget(AllLabels[4],4+i,10,1,1);
    		layout->addWidget(RewardSize[i],4+i,11,1,1);
    		
    		connect(Stimulus[i], static_cast<void (QComboBox::*)(int)>(&QComboBox::currentIndexChanged),this,
    		[=](int index){ if(index==0)StimulFrequency[i]->setEnabled(true);else StimulFrequency[i]->setEnabled(false); });
    			
    		StimulFrequency[i]->setMaximum(20);
  			RewardSize[i]->setMaximum(1000);
  			StimulFrequency[i]->setValue(F_Reco.BeepFreq[i]);
  			RewardSize[i]->setValue(F_Reco.RewardSize[i]);
  			Stimulus[i]->setCurrentIndex(F_Reco.Stimulus[i]);
  			
  			if(RecoBoxSubMode==1)
  				lineEditForagingSequence->setEnabled(false);
  			if(RecoBoxSubMode==0)
  				lineEditForagingSequence->setEnabled(true);

    	}
    	
    	ForagingTimeOut->setValue(F_Reco.Timeout);
    	ForagingRecoZone->setValue(F_Reco.RECO_Zone);
    	ForagingRepeatFreq->setValue(F_Reco.Repeat);
    	ForagingRecoPort->setValue(F_Reco.Port);
    	connect(RecoBoxNumbers, static_cast<void (QSpinBox::*)(int)>(&QSpinBox::valueChanged),this, &SetUpConfiguration::AddRemoveRecoBox);			
		connect(ForagingState, static_cast<void (QComboBox::*)(int)>(&QComboBox::currentIndexChanged),this,&SetUpConfiguration::RecoModeChanged);
   	}
   	
   	connect(RecoMode, static_cast<void (QComboBox::*)(int)>(&QComboBox::currentIndexChanged),this,&SetUpConfiguration::RecoModeChanged);
    QuestionPoints3->setLayout(layout);
}


void SetUpConfiguration::OutputConfigFile()
{
	string defaultFilename="Configuration-"+currentDateTime();
    QString qstr = QString::fromStdString(defaultFilename);
    string path(getenv("HOME"));
    path=path+"/Desktop";
	QString defualtpath = QString::fromStdString(path);
	
	QuestionPoints4 = new QGroupBox(tr("Save Configuration"));
	QGridLayout *layout = new QGridLayout;
    ChooseOutPutPath = new QPushButton(tr("Browse"));
    QLabel *DirName = new QLabel(tr("Name"));
    QLabel *LabelOutputFolder = new QLabel(tr("Path"));
    lineEditSavingConfig = new QLineEdit(defualtpath);
    lineEditConfigName=new QLineEdit(qstr);
    
    layout->addWidget(DirName,0,0,1,1);
    layout->addWidget(lineEditConfigName,0,1,1,1);
    layout->addWidget(LabelOutputFolder,1,0,1,1);
    layout->addWidget(lineEditSavingConfig,1,1,1,1);
    layout->addWidget(ChooseOutPutPath,1,2,1,1);
    
    QuestionPoints4->setLayout(layout);
}


void SetUpConfiguration::FinishedButton()
{
	QuestionPoints5 = new QGroupBox(tr(" "));
	QGridLayout *layout = new QGridLayout;
   	SavingConfigButton=new QPushButton(tr("Save Configuration"));
	CancelConfigButton=new QPushButton(tr("Cancel and Close"));
    QLabel *Spacer = new QLabel(tr(" "));

    
    layout->addWidget(CancelConfigButton,0,0);
    layout->addWidget(Spacer,0,1,1,4);
    layout->addWidget(SavingConfigButton,0,5);
   
    QuestionPoints5->setLayout(layout);
}


void SetUpConfiguration::RecoModeChanged()
{
	AssigneInputs();
	
	mainLayout->removeWidget(QuestionPoints3);	
	QuestionPoints3->setParent(NULL);
	cout<<RecoBoxMode<<endl;
	LoadRECOBox(RecoBoxMode,RecoBoxSubMode);
	mainLayout->addWidget(QuestionPoints3,9,0,1,2);
	adjustSize();
}



void SetUpConfiguration::LiveClicked()
{
	AssigneInputs();
	HoldCheckVal=HoldCheckVal+1;
	if(HoldCheckVal%2==0)
	{
		QuestionPoints2->setParent(NULL);
		LoadLiveCamera();
		mainLayout->addWidget(QuestionPoints2,3,0,2,1);
		adjustSize();
		setMinimumWidth(w);
		HasLiveView=1;
	}
	if(HoldCheckVal%2==1)
	{
		mainLayout->removeWidget(QuestionPoints2);
		QuestionPoints2->setParent(NULL);
		adjustSize();
		setMinimumWidth(w);
		HasLiveView=0;
	}
}

void SetUpConfiguration::CloseUpClicked()
{
	AssigneInputs();
	HoldCheckValClose=HoldCheckValClose+1;
	if(HoldCheckValClose%2==0)
	{
		QuestionPointsClose->setParent(NULL);
		LoadLiveCamera();
		mainLayout->addWidget(QuestionPointsClose,6,0,2,2);
		adjustSize();
		setMinimumWidth(w);
		HasCloseUp=1;
	}
	if(HoldCheckValClose%2==1)
	{
		mainLayout->removeWidget(QuestionPointsClose);
		QuestionPointsClose->setParent(NULL);
		adjustSize();
		setMinimumWidth(w);
		HasCloseUp=0;
	}
}

void SetUpConfiguration::RecoBoxClicked()
{
	AssigneInputs();
	HoldCheckVal2=HoldCheckVal2+1;
	if(HoldCheckVal2%2==0)
	{	
		
		QuestionPoints3->setParent(NULL);
		LoadRECOBox(RecoBoxMode,RecoBoxSubMode);
		mainLayout->addWidget(QuestionPoints3,9,0,1,2);
		adjustSize();
		setMinimumWidth(w);
		HasRecoBox=1;
	}
	if(HoldCheckVal2%2==1)
	{
		mainLayout->removeWidget(QuestionPoints3);
		QuestionPoints3->setParent(NULL);
		adjustSize();
		setMinimumWidth(w);
		HasRecoBox=0;
	}
}


void SetUpConfiguration::AddRemoveRecoBox()
{
	AssigneInputs();
	ForagingRecoNumbers = RecoBoxNumbers->value();
	mainLayout->removeWidget(QuestionPoints3);	
	adjustSize();
	QuestionPoints3->setParent(NULL);
	LoadRECOBox(RecoBoxMode,RecoBoxSubMode);
	mainLayout->addWidget(QuestionPoints3,9,0,1,2);	
}


void SetUpConfiguration::AssigneInputs()
{


	CalibrationFilePath=lineEditLoading->text();

	LiveCamera.Exposure=LiveCameraExposure->value();
	LiveCamera.Gain=LiveCameraGain->value();
	LiveCamera.Width=LiveCameraResolutionW->value();
	LiveCamera.Height=LiveCameraResolutionH->value();

    CLUP.Exposure=CloseExposure->value();
	CLUP.Gain=CloseGain->value();
    CLUP.Width=CloseResolutionW->value();
	CLUP.Height=CloseResolutionH->value();
    CLUP.OffsetZ=CloseOffsetZ->value();
	CLUP.OffsetY=CloseOffsetY->value();
	CLUP.CL_Position=lineEditClosePosition->text();
	CLUP.MinMaxZ[0]=MinZ->value();
	CLUP.MinMaxY[0]=MinY->value();
	CLUP.MinMaxZ[1]=MaxZ->value();
	CLUP.MinMaxY[1]=MaxY->value();

	RecoBoxMode=RecoMode->currentIndex();
	if(RecoBoxMode==0)
		RecoBoxSubMode=ConditioningState->currentIndex();
	if(RecoBoxMode==1)
	    RecoBoxSubMode=ForagingState->currentIndex();
	    
	C_Reco.SelfPos=lineEditConditioningRecoLocation->text();
	C_Reco.IP=lineEditConditioningIP->text();
	C_Reco.TargetPos=lineEditConditioningPlace->text();
	C_Reco.RECO_Zone=ConditioningRewardZone->value();
	C_Reco.Target_Zone=ConditioningZoneSpace->value();
	C_Reco.BeepFreq=ConditioningBuzzFreq->value();
	C_Reco.RewardSize=ConditioningRewardSize->value();
	C_Reco.Timeout=ConditioningTimeOut->value();
	C_Reco.Repeat=ConditioningRepeatFreq->value();
	C_Reco.ConditioningStumulus=StimulusMode->currentIndex();
	C_Reco.Port=ConditioningRecoPort->value();
	C_Reco.BehaviorPort=ReceivingBehaviorPort->value();

	F_Reco.Timeout=ForagingTimeOut->value();
	F_Reco.RECO_Zone=ForagingRecoZone->value();
	F_Reco.Repeat=ForagingRepeatFreq->value();
	F_Reco.ForagingSeq=lineEditForagingSequence->text();
	F_Reco.Port=ForagingRecoPort->value();
	for(int i=0;i<ForagingRecoNumbers;i++)
	{
		F_Reco.BeepFreq[i]=StimulFrequency[i]->value();
		F_Reco.RewardSize[i]=RewardSize[i]->value();
		F_Reco.Stimulus[i]=Stimulus[i]->currentIndex();
		F_Reco.IP[i]=lineEditForagingIPs[i]->text();
		F_Reco.SelfPos[i]=lineEditForagingLocations[i]->text();
	}
	
	SaveCongigurationFilePath=lineEditSavingConfig->text()+tr("/")+lineEditConfigName->text()+tr(".ini");    
}

void SetUpConfiguration::SaveTheConfigFile()
{
	AssigneInputs();
	
	string ReadCalibPath=CalibrationFilePath.toStdString();
	cout<<ReadCalibPath<<endl;
	ifstream CalibFile (ReadCalibPath, ifstream::in);
	if (CalibFile.fail())
	{
		QMessageBox msgBox;
		msgBox.setText("Can not open the Calibration file. Please check again.");
		msgBox.exec();
		return;
	}
	ofstream ConfigOutput;
	ConfigOutput.open(SaveCongigurationFilePath.toStdString());
	if(!ConfigOutput.is_open()){
		QMessageBox msgBox;
		msgBox.setText("The Configuration output path is not valid. Please check again.");
		msgBox.exec();
	}

	while(! CalibFile.eof())
	{
		string ss;
		getline(CalibFile,ss);
		ConfigOutput<<ss<<endl;
	}
	
	if(HasLiveView==1){
		ConfigOutput<<endl<<endl<<endl<<"[LiveCamera]"<<endl;
		ConfigOutput<<"Exposure = "<<LiveCamera.Exposure<<endl;
		ConfigOutput<<"Gain = "<<LiveCamera.Gain<<endl;
		ConfigOutput<<"Resolution = "<<LiveCamera.Width<<" "<<LiveCamera.Height<<endl<<endl;
	}


	if(HasCloseUp==1)
	{
		ConfigOutput<<endl<<endl<<endl<<"[CloseUp_System]"<<endl;
		ConfigOutput<<"Z_Offset = "<<CLUP.OffsetZ<<endl;
		ConfigOutput<<"Min_Max_Z = "<<CLUP.MinMaxZ[0]<<" "<<CLUP.MinMaxZ[1]<<endl;
		ConfigOutput<<"Y_Offset = "<<CLUP.OffsetY<<endl;
		ConfigOutput<<"Min_Max_Y = "<<CLUP.MinMaxY[0]<<" "<<CLUP.MinMaxY[1]<<endl;
		ConfigOutput<<"CloseUp_Position = "<<CLUP.CL_Position.toStdString()<<endl;
		
		ConfigOutput<<"Exposure = "<<CLUP.Exposure<<endl;
		ConfigOutput<<"Gain = "<<CLUP.Gain<<endl;
		ConfigOutput<<"Resolution = "<<CLUP.Width<<" "<<CLUP.Height<<endl<<endl;	
	}





	if(HasRecoBox==1){
		ConfigOutput<<endl<<endl<<endl<<"[RecoBoxConfiguration]"<<endl;
	
		string allstimulus[4]={"Buzz","Click","LED","WhiteNoise"};
		if(RecoBoxMode==0)
		{
			ConfigOutput<<"Mode = "<<"Conditioning"<<endl;
			if(RecoBoxSubMode==0)
				ConfigOutput<<"Type = "<<"Place"<<endl;
			else
				ConfigOutput<<"Type = "<<"Behaviour"<<endl;
				ConfigOutput<<"BehaviorInfoPort = "<<C_Reco.BehaviorPort<<endl;
				
			ConfigOutput<<"RecoBoxPosition = "<<C_Reco.SelfPos.toStdString()<<endl;
			ConfigOutput<<"RecoBoxIP = "<<C_Reco.IP.toStdString()<<endl;
			ConfigOutput<<"RecoBoxPort = "<<C_Reco.Port<<endl;
			ConfigOutput<<"TargetPosition = "<<C_Reco.TargetPos.toStdString()<<endl;
			ConfigOutput<<"RecoBoxZone = "<<C_Reco.RECO_Zone<<endl;
			ConfigOutput<<"TargetZone = "<<C_Reco.Target_Zone<<endl;
			ConfigOutput<<"Stimulus = "<<allstimulus[C_Reco.ConditioningStumulus];
			if(C_Reco.ConditioningStumulus==0)
					ConfigOutput<<C_Reco.BeepFreq;
			ConfigOutput<<endl;
			ConfigOutput<<"RewardSize = "<<C_Reco.RewardSize<<endl;
			ConfigOutput<<"TimeOut = "<<C_Reco.Timeout<<endl;
			ConfigOutput<<"RepeatFreq = "<<C_Reco.Repeat<<endl;
		
		
		}
		if(RecoBoxMode==1)
		{
			ConfigOutput<<"Mode = "<<"Foraging"<<endl;
			if(RecoBoxSubMode==0)
				ConfigOutput<<"Type = "<<"Sequenced"<<endl;
			else
				ConfigOutput<<"Type = "<<"Random"<<endl;
				
			ConfigOutput<<"Num_of_RecoBoxes = "<<ForagingRecoNumbers<<endl;
			if(RecoBoxSubMode==0)
				ConfigOutput<<"Sequence = "<<F_Reco.ForagingSeq.toStdString()<<endl;
				
			ConfigOutput<<"TimeOut = "<<F_Reco.Timeout<<endl;
			ConfigOutput<<"RecoBoxZone = "<<F_Reco.RECO_Zone<<endl;
			ConfigOutput<<"RepeatFreq = "<<F_Reco.Repeat<<endl;
			ConfigOutput<<"RecoBoxPort = "<<F_Reco.Port<<endl;
		
		
			ConfigOutput<<endl<<"IP_Address =\t";
			for(int i=0;i<ForagingRecoNumbers;i++)
				ConfigOutput<<F_Reco.IP[i].toStdString()<<"\t\t";
			
			ConfigOutput<<endl<<"Locations =\t";
			for(int i=0;i<ForagingRecoNumbers;i++)
				ConfigOutput<<F_Reco.SelfPos[i].toStdString()<<"\t\t";
			
			ConfigOutput<<endl<<"Stimulus =\t";
			for(int i=0;i<ForagingRecoNumbers;i++){
				ConfigOutput<<allstimulus[F_Reco.Stimulus[i]];
				if(F_Reco.Stimulus[i]==0)
					ConfigOutput<<F_Reco.BeepFreq[i];
				ConfigOutput<<"\t\t\t";
				}
			
			ConfigOutput<<endl<<"RewardSize =\t";
			for(int i=0;i<ForagingRecoNumbers;i++)
				ConfigOutput<<F_Reco.RewardSize[i]<<"\t\t\t";
		

		
		}
	}
	
close();
	

	
}

