#ifndef SETUPCONFIGURATION_H
#define SETUPCONFIGURATION_H

#include <QApplication>
#include <QPushButton>
#include <QProgressBar>

#include <QSlider>
#include <QtWidgets/QApplication>
#include <QPushButton>

#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <QInputDialog>
#include <QDir>
#include <QFormLayout>
#include  <QLayout>

#include  <QGroupBox>
#include <QMainWindow>


#include <QTextEdit>
#include <QDialogButtonBox>
#include <QtWidgets/QLabel>
#include <QMenuBar>
#include <QSpinBox>
#include <QComboBox>
#include <QCheckBox>
#include <QSlider>


#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "opencv2/opencv.hpp"

using namespace std;
extern int IterNum;
class SetUpConfiguration : public QDialog
{
    
Q_OBJECT

public:
    SetUpConfiguration();
    void LoadMatrix();
    void LoadLiveCamera();
   	void LoadRECOBox(int mode,int submode);
   	void LoadCloseUp();
   	void AssigneInputs();
   	void OutputConfigFile();
   	void FinishedButton();


   		
   	int HoldCheckVal;
   	int HoldCheckVal2;
   	int HoldCheckValClose;
   	
	int RecoBoxMode;
	int RecoBoxSubMode;
	int ForagingRecoNumbers;
	QString CalibrationFilePath;
	QString SaveCongigurationFilePath;
	
	  class LiveCameraParams {
		  public:
		  	int Exposure=1000;
		  	int Gain=0;
		  	int Width=640;
		  	int Height=512;
      };
      class ConditioningRecoBoxParams {
		  public:
		  	QString SelfPos=tr("0 0 0");
		  	QString TargetPos=tr("10 10 10");
		  	QString IP=tr("10.0.0.201");
		  	int Port=2390;
		  	int RECO_Zone=10;
		  	int Target_Zone=20;
		  	int BeepFreq=9;
		  	int Repeat=1;
		  	int Timeout=30;
		  	int RewardSize=100;
		  	int ConditioningStumulus=0;
		  	int BehaviorPort=7777;
      };
      
      class ForagingRecoBoxParams {
		  public:
		  	int Port=2390; 
		  	QString ForagingSeq=tr("");
		  	QString SelfPos[9];
		  	QString IP[9];
		  	int RECO_Zone=10;
		  	int BeepFreq[9];
		  	int Repeat=1;
		  	int Timeout=30;
		  	int RewardSize[9];
		  	int Stimulus[9];
      };
      
      class CloseUpParams {
		  public:
			int Exposure=10000;
		  	int Gain=5;
		  	int Width=640;
		  	int Height=512;
		  	int OffsetZ=2048;
		  	int OffsetY=2048;
		  	int MinMaxZ[2]={OffsetZ-512,OffsetZ+512};
		  	int MinMaxY[2]={OffsetY-512,OffsetY+512};
		  	QString CL_Position=tr("0 0 0");
      };
      
   LiveCameraParams LiveCamera;
   ConditioningRecoBoxParams C_Reco;
   ForagingRecoBoxParams F_Reco;
   CloseUpParams CLUP;

private:
	QGridLayout *mainLayout;

	QGroupBox *QuestionPoints1;
	QPushButton *BrowseButton;
	QLineEdit *lineEditLoading;
	

	QGroupBox *QuestionPoints2;
	QCheckBox *checkbox;
	QSpinBox *LiveCameraExposure;
	QSpinBox *LiveCameraGain;
	QSpinBox *LiveCameraResolutionW;
	QSpinBox *LiveCameraResolutionH;
	
	
	
	
	QGroupBox *QuestionPointsClose;
	QCheckBox *checkboxClose;
	QSpinBox *CloseExposure;
	QSpinBox *CloseGain;
	QSpinBox *CloseResolutionW;
	QSpinBox *CloseResolutionH;
	QSpinBox *CloseOffsetZ;
	QSpinBox *CloseOffsetY;
	QSpinBox *MinZ;
	QSpinBox *MaxZ;
	QSpinBox *MinY;
	QSpinBox *MaxY;
	QLineEdit *lineEditClosePosition;
	
	
	
	QGroupBox *QuestionPoints3;
	QCheckBox *checkbox2;
	QComboBox *RecoMode;
	
	
	QComboBox *ConditioningState;
	QLineEdit *lineEditConditioningIP;
	QComboBox *StimulusMode;
	QSpinBox  *ConditioningBuzzFreq;
	QSpinBox  *ConditioningRepeatFreq;
	QLineEdit *lineEditConditioningPlace;
	QSpinBox *ConditioningRewardZone;
	QSpinBox *ConditioningTimeOut;
	QSpinBox *ConditioningZoneSpace;
	QSpinBox *ConditioningRewardSize;
	QLineEdit *lineEditConditioningRecoLocation;
	QSpinBox  *ConditioningRecoPort;
	QSpinBox  *ReceivingBehaviorPort;
	
	QComboBox *ForagingState;
	QLineEdit *lineEditForagingSequence;
	QLineEdit *lineEditForagingIPs[9];
	QLineEdit *lineEditForagingLocations[9];
	QComboBox *Stimulus[9];
	QSpinBox  *StimulFrequency[9];
	QSpinBox  *RewardSize[9];
	QSpinBox  *RecoBoxNumbers;
	QSpinBox  *ForagingRepeatFreq;
	QSpinBox  *ForagingTimeOut;
	QSpinBox  *ForagingRecoZone;
	QSpinBox  *ForagingRecoPort;
	
	QGroupBox *QuestionPoints4;
	QPushButton *ChooseOutPutPath;
	QLineEdit *lineEditSavingConfig;
	QLineEdit *lineEditConfigName;
	
	QGroupBox *QuestionPoints5;
	QPushButton *SavingConfigButton;
	QPushButton *CancelConfigButton;
	
	
	
public slots:
    	void ChooseCalibrationConfig();
    	void LiveClicked();
    	void CloseUpClicked();
    	void RecoBoxClicked();
    	void RecoModeChanged();
    	void AddRemoveRecoBox();
    	void ChooseSaveDirConfiguration();
    	void SaveTheConfigFile();
    	
   
};

#endif // WINDOW_H
