#include <iostream>
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "SetUpConfiguration.h"
#include "LoadConfiguration.h"
#include "ManualRecoBox.h"
#include "window.h"
#include "CalibrationForm.h"
#include <QApplication>
#include <QPushButton>
#include <QProgressBar>
#include <QSlider>
#include <QtWidgets/QApplication>
#include <QPushButton>
#include <QInputDialog>
#include <QDir>
#include <QFormLayout>
#include <QLayout>
#include <QtWidgets/QLabel>
#include <QGroupBox>
#include <QMainWindow>
#include <QFileDialog>
#include <QTextEdit>
#include <QPainter>


using namespace std;


extern void *Track(void *threadid);

Window::Window(QWidget *parent) :
 QWidget(parent)
 {
  // Set size of the window
  setFixedSize(960, 600);
  move(100,100);
  setWindowTitle(tr("Etholoop 1.0.0"));
  
  // Create and position the button
  int x=380;int y=150; int w=200; int h=35;
  string buttonLables[4] = {"Run Etholoop","Run RECO-Box","3D Calibration","Create Config File"};
  for(int i=0;i<4;i++)
  {
  	QString qstr = QString::fromStdString(buttonLables[i]);
  	m_button[i] = new QPushButton(qstr, this);

  		m_button[i]->setGeometry(x, y+i*50, w, h);

  	m_button[i]->setStyleSheet("QPushButton { font-size: 10pt; font-weight: bold; color: black;  border-width: 1px; border-color: white white white white; }");
  }


  labeltetx = new QLabel(this);
  labeltetx->setMinimumWidth(200);
  labeltetx->move(x, y+36);

  //signals ans slots                                                
  connect(m_button[0], SIGNAL (clicked()), this, SLOT (OpenLoadingPage()));
  connect(m_button[1], SIGNAL (clicked()), this, SLOT (OpenRecoPage()));
  connect(m_button[2], SIGNAL (clicked()), this, SLOT (OpenCalibrationPage()));
  connect(m_button[3], SIGNAL (clicked()), this, SLOT (OpenConfigurationPage()));

 }
 
void Window::ChooseDir()
{
	QString QfileName = QFileDialog::getOpenFileName(this,tr("Choose a config file"), "/home/ali/Desktop", tr("txt files (*.txt)"));
	string filename=QfileName.toStdString();
	int length = QfileName.length();
	QfileName.remove(0, length-35); 
	QfileName="...."+QfileName;
	QFont font = labeltetx->font();
	font.setPointSize(8);
	labeltetx->setText(QfileName);
	labeltetx->setFont(font);
	labeltetx->setStyleSheet("QLabel { color : white; }");
}

void Window::OpenCalibrationPage()
{
	CalibrationForm dd;
	dd.setModal(true);
	dd.exec();
}

void Window::OpenConfigurationPage()
{
	SetUpConfiguration dd2;
	dd2.setModal(true);
	dd2.exec();
}

void Window::OpenLoadingPage()
{
	LoadConfiguration dd2;
	dd2.setModal(true);
	dd2.exec();
}

void Window::OpenRecoPage()
{
	ManualRecoBox dd2;
	dd2.setModal(true);
	dd2.exec();
}

void Window::paintEvent(QPaintEvent *p2)
{
    QPixmap pixmap;
    QPainter paint(this);
    paint.drawPixmap( 0, 0, QPixmap("../QtFiles/Lemur.png").scaled(size()));
    QWidget::paintEvent(p2);
}
 


