

#ifndef CLOSEUP_H
#define CLOSEUP_H

#include <fstream>
#include <sys/time.h>
#include <unistd.h>
#include "opencv2/opencv.hpp"
#include "dynamixel_sdk/dynamixel_sdk.h"
#include <cmath>

using namespace std;
using namespace cv;



// Control table address
#define ADDR_MX_TORQUE_ENABLE           64                  // Control table address is different in Dynamixel model
#define ADDR_MX_GOAL_POSITION           116
#define ADDR_MX_PRESENT_POSITION        132
// Protocol version
#define PROTOCOL_VERSION                2.0                 // See which protocol version is used in the Dynamixel
// Default setting
#define DXL1_ID                        	3                	// Dynamixel ID: 1
#define DXL2_ID                       	4                	// Dynamixel ID: 1
#define BAUDRATE                        1000000
#define DEVICENAME                      "/dev/ttyUSB0"      // Check which port is being used on your controller
#define TORQUE_ENABLE                   1                   // Value for enabling the torque
#define TORQUE_DISABLE                  0                   // Value for disabling the torque
// Data Byte Length
#define LEN_MX_GOAL_POSITION           	4
#define LEN_MX_PRESENT_POSITION			4

// Initialize PortHandler instance -- Set the port path and get methods and members of PortHandlerLinux or PortHandlerWindows
dynamixel::PortHandler *portHandler = dynamixel::PortHandler::getPortHandler(DEVICENAME);
// Initialize PacketHandler instance --Set the protocol version and get methods and members of Protocol1PacketHandler or Protocol2PacketHandler
dynamixel::PacketHandler *packetHandler = dynamixel::PacketHandler::getPacketHandler(PROTOCOL_VERSION);
// Initialize GroupSyncWrite instance
dynamixel::GroupSyncWrite groupSyncWrite(portHandler, packetHandler, ADDR_MX_GOAL_POSITION, LEN_MX_GOAL_POSITION);


float dObjectCloseup_x;
float dObjectCloseup_y;
float dObjectCloseup_z;
float dObjectCloseup_xy;
float dObjectCloseup;

// distance between the origin and the close up
float dOriginCloseup_x;
float dOriginCloseup_y;
float dOriginCloseup_z;

// Offsets of the motors
int alphaOffset;
int betaOffset;

//ranges of the motors
int alphaRange[2];
int betaRange[2];

void AssigneInputsDynamixel (int OffsetAlpha, int OffsetBeta, int RangesAlpha[2], int RangesBeta[2],Point3f CloseUpPosition);
void connectionDynamixel();
void setDynamixelMotors(Mat point3DReal);



#endif
