#!/bin/bash

cp -r EthoLoop ~/Desktop

cd ~/Downloads/

### Update and upgrade ###
sudo apt -y update
sudo apt -y upgrade


### install libraries and dependencies ###
sudo apt-get -y install build-essential checkinstall cmake pkg-config yasm
sudo apt-get -y install build-essential make cmake cmake-curses-gui g++
sudo apt-get -y install git gfortran
sudo apt-get -y install libjpeg8-dev libjasper-dev libpng12-dev
sudo apt-get -y install libavcodec-dev libavformat-dev libswscale-dev libdc1394-22-dev libavutil-dev
sudo apt-get -y install libtiff5-dev
sudo apt-get -y install libxine2-dev libv4l-dev libeigen3-dev
sudo apt-get -y install libgstreamer0.10-dev libgstreamer-plugins-base0.10-dev
sudo apt-get -y install qt5-default libgtk2.0-dev libtbb-dev
sudo apt-get -y install libatlas-base-dev  libglew1.6-dev
sudo apt-get -y install libfaac-dev libmp3lame-dev libtheora-dev
sudo apt-get -y install libvorbis-dev libxvidcore-dev
sudo apt-get -y install libopencore-amrnb-dev libopencore-amrwb-dev
sudo apt-get -y install x264 v4l-utils
sudo apt-get -y install libgstreamer1.0 libgstreamer1.0-dev libgstreamer-plugins-bad1.0-0 libgstreamer-plugins-base1.0-0 libgstreamer-plugins-base1.0-dev
sudo apt-get -y install libgtkglext1 libgtkglext1-dev
sudo apt-get -y install libcanberra-gtk-module libcanberra-gtk3-module


### Then get XIMEA drivers ###
sudo apt-get install ca-certificates
wget https://www.ximea.com/downloads/recent/XIMEA_Linux_SP.tgz

tar xzf XIMEA_Linux_SP.tgz
cd package

sudo ./install

sudo gpasswd -a "$(whoami)" plugdev
if [ -f /etc/rc.local ]
then
sudo sed -i '/^exit/ d' /etc/rc.local
else
echo '#!/bin/sh -e'                                            | sudo tee    /etc/rc.local > /dev/null
fi
echo 'echo 0 > /sys/module/usbcore/parameters/usbfs_memory_mb' | sudo tee -a /etc/rc.local > /dev/null
echo 'exit 0'                                                  | sudo tee -a /etc/rc.local > /dev/null
sudo chmod a+x /etc/rc.local
echo 'KERNEL=="emc_freq_min", ACTION=="add", GROUP="plugdev", MODE="0660"' | sudo tee /etc/udev/rules.d/99-emc_freq.rules > /dev/null
sudo groupadd -fr realtime
echo '*         - rtprio   0' | sudo tee    /etc/security/limits.d/ximea.conf > /dev/null
echo '@realtime - rtprio  81' | sudo tee -a /etc/security/limits.d/ximea.conf > /dev/null
echo '*         - nice     0' | sudo tee -a /etc/security/limits.d/ximea.conf > /dev/null
echo '@realtime - nice   -16' | sudo tee -a /etc/security/limits.d/ximea.conf > /dev/null
sudo gpasswd -a "$(whoami)" realtime
sudo mkdir /etc/systemd/system/user@.service.d
echo '[Service]'                                                                                 | sudo tee    /etc/systemd/system/user@.service.d/cgroup.conf > /dev/null
echo 'PermissionsStartOnly=true'                                                                 | sudo tee -a /etc/systemd/system/user@.service.d/cgroup.conf > /dev/null
echo 'ExecStartPost=-/bin/sh -c "echo 950000 > /sys/fs/cgroup/cpu/user.slice/cpu.rt_runtime_us"' | sudo tee -a /etc/systemd/system/user@.service.d/cgroup.conf > /dev/null


### Then OPENCV ###
cd ~/Downloads/

git clone https://github.com/opencv/opencv.git
cd opencv
git checkout "3.4"

mkdir build
cd build

cmake -D CMAKE_BUILD_TYPE=RELEASE -D CMAKE_INSTALL_PREFIX=/usr/local -D WITH_TBB=ON -D WITH_V4L=ON -D WITH_QT=ON -D WITH_OPENGL=ON -D WITH_XIMEA=ON -D WITH_TIFF=OFF ..

make -j4
sudo make install
sudo sh -c 'echo "/usr/local/lib" >> /etc/ld.so.conf.d/opencv.conf'
sudo ldconfig

### JSONCPP (if needed) ###
sudo apt-get install libjsoncpp-dev

### gnuplot (if needed) ###
sudo apt-get -y install -y gnuplot

### matplotlib (if needed) ###
sudo apt-get -y build-dep python-matplotlib

### Dynamixel SDK ###
sudo apt-get -y install gcc-5
sudo apt-get -y install gcc-multilib g++-multilib

cd ~/Downloads/

git clone https://github.com/ROBOTIS-GIT/DynamixelSDK.git
cd DynamixelSDK*/c++/build/linux64

make
sudo make install


cd ~/Desktop/EthoLoop/bin
cmake .
make

### reboot ###
sudo reboot








